/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x8 = XEXP (x1, 1);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode
          || GET_MODE (x4) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || GET_MODE (x2) != E_PSImode
          || GET_MODE (x3) != E_PSImode)
        return -1;
      res = pattern0 (x4);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      res = pattern1 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 24)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 24)
    return -1;
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 0;

    case E_QImode:
      if (GET_MODE (x2) != E_QImode
          || GET_MODE (x3) != E_QImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 0
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  return 0;
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case AND:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !nonmemory_operand (operands[2], E_HImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x2) != E_PSImode
              || GET_MODE (x3) != E_PSImode
              || !nonmemory_operand (operands[2], E_PSImode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 2;

            case E_HImode:
              if (!register_operand (operands[1], E_HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || !nonmemory_operand (operands[2], E_SImode))
            return -1;
          res = pattern30 (x4);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern53 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode
      || !register_operand (operands[1], E_PSImode)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x4, 2);
  operands[1] = x7;
  if (!const_0_to_7_operand (operands[1], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !nox_general_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!nonimmediate_operand (operands[0], E_QQmode)
          || !nox_general_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!nonimmediate_operand (operands[0], E_UQQmode)
          || !nox_general_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      return 3;

    case E_HQmode:
      if (!nonimmediate_operand (operands[0], E_HQmode)
          || !nox_general_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!nonimmediate_operand (operands[0], E_UHQmode)
          || !nox_general_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!nonimmediate_operand (operands[0], E_HAmode)
          || !nox_general_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!nonimmediate_operand (operands[0], E_UHAmode)
          || !nox_general_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_PSImode:
      return 8;

    case E_SImode:
      return 9;

    case E_SQmode:
      return 10;

    case E_USQmode:
      return 11;

    case E_SAmode:
      return 12;

    case E_USAmode:
      return 13;

    case E_SFmode:
      return 14;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (GET_CODE (operands[3]))
        {
        case CONST_INT:
          return pattern75 (x1); /* [-1, 3] */

        case REG:
        case SUBREG:
          if (!register_operand (operands[3], E_QImode)
              || !register_operand (operands[0], E_QImode)
              || GET_MODE (x1) != E_QImode
              || GET_MODE (x2) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case XOR:
      if (GET_MODE (x5) != E_QImode
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || GET_MODE (x2) != E_QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      if (!const_int_operand (operands[4], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFTRT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !const7_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !const15_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !const23_operand (operands[2], E_QImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !const31_operand (operands[2], E_QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  return 0;
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC_VOLATILE
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 6
      || GET_MODE (x1) != E_BLKmode)
    return -1;
  return 0;
}

int
pattern107 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != i2)
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode
      || !register_operand (operands[1], E_PSImode)
      || !nonmemory_operand (operands[2], E_QImode)
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern117 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 24
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 24
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 26
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  return pattern116 (x8); /* [-1, 0] */
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode)
          || pattern125 (x1) != 0)
        return -1;
      return 0;

    case AND:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      res = pattern84 (x1);
      if (res >= 0)
        return res + 1; /* [1, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern131 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern131 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern131 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern131 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !single_one_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !single_one_operand (operands[2], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !single_one_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 25
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern143 (x4); /* [-1, 1] */
}

int
pattern147 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (REGNO (x7))
    {
    case 24:
      if (REGNO (x3) != 24)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_HQmode:
          if (GET_MODE (x6) != E_HQmode
              || GET_MODE (x7) != E_HQmode)
            return -1;
          return 0;

        case E_HAmode:
          if (GET_MODE (x6) != E_HAmode
              || GET_MODE (x7) != E_HAmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (REGNO (x3) != 22)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SAmode:
          if (GET_MODE (x6) != E_SAmode
              || GET_MODE (x7) != E_SAmode)
            return -1;
          return 2;

        case E_SQmode:
          if (GET_MODE (x6) != E_SQmode
              || GET_MODE (x7) != E_SQmode)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern162 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern166 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern172 (rtx x1, unsigned int i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  return pattern100 (x4, 
i1, 
i3); /* [-1, 0] */
}

int
pattern177 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  return pattern176 (x4); /* [-1, 0] */
}

int
pattern182 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!reg_or_low_io_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!reg_or_low_io_operand (operands[1], E_HImode)
              || !const_0_to_15_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!reg_or_low_io_operand (operands[1], E_PSImode)
              || !const_0_to_23_operand (operands[2], E_QImode))
            return -1;
          return 2;

        case E_SImode:
          if (!reg_or_low_io_operand (operands[1], E_SImode)
              || !const_0_to_31_operand (operands[2], E_QImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode))
            return -1;
          return 4;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode)
              || !const_0_to_15_operand (operands[2], E_QImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern199 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_MODE (x4) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (pnum_clobbers == NULL
          || !pseudo_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_MODE (x4) != E_SImode
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          res = pattern198 (
E_QImode);
          if (res >= 0)
            return res + 1; /* [1, 2] */
          return -1;

        case E_HImode:
          res = pattern198 (
E_HImode);
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || !register_operand (operands[3], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  return 0;
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case LSHIFTRT:
      return pattern219 (x3); /* [-1, 2] */

    case ASHIFTRT:
      res = pattern219 (x3);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], E_HImode))
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  return 0;
}

int
pattern230 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG)
    return -1;
  return 0;
}

int
pattern236 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (x3))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      res = pattern4 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern244 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_UQQmode:
      return pattern108 (x1, 
E_UQQmode); /* [-1, 0] */

    case E_UHQmode:
      if (pattern108 (x1, 
E_UHQmode) != 0)
        return -1;
      return 1;

    case E_UHAmode:
      if (pattern108 (x1, 
E_UHAmode) != 0)
        return -1;
      return 2;

    case E_USAmode:
      if (pattern108 (x1, 
E_USAmode) != 0)
        return -1;
      return 3;

    case E_USQmode:
      if (pattern108 (x1, 
E_USQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern249 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_PSImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 18
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XEXP (x8, 0);
  operands[0] = x9;
  if (!pseudo_register_operand (operands[0], E_PSImode))
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != E_PSImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!pseudo_register_operand (operands[1], E_PSImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  if (!pseudo_register_operand (operands[2], E_PSImode))
    return -1;
  x13 = XEXP (x4, 0);
  operands[3] = x13;
  if (!pseudo_register_operand (operands[3], E_PSImode))
    return -1;
  x14 = XEXP (x5, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x5, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  return 0;
}

int
pattern255 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 26
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern259 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_PSImode
      || !register_operand (operands[1], E_PSImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern265 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i1
      || GET_MODE (x5) != i4)
    return -1;
  return 0;
}

int
pattern269 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !pseudo_register_operand (operands[1], i1)
      || !pseudo_register_or_const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern275 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!pseudo_register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!pseudo_register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern281 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (REGNO (x4))
    {
    case 22:
      if (GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 24
          || GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != UMOD
          || GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24
          || GET_MODE (x8) != E_QImode)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 22
          || GET_MODE (x9) != E_QImode)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 25
          || GET_MODE (x10) != E_QImode)
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      if (REGNO (x12) != 23
          || GET_MODE (x12) != E_QImode
          || GET_MODE (x3) != E_QImode)
        return -1;
      x13 = XEXP (x3, 0);
      if (GET_MODE (x13) != E_QImode)
        return -1;
      return 0;

    case 18:
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 22)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      res = pattern280 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern298 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (REGNO (x4))
    {
    case 22:
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 24)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 22)
        return -1;
      switch (GET_MODE (x5))
        {
        case E_QQmode:
          if (GET_MODE (x3) != E_QQmode
              || GET_MODE (x4) != E_QQmode
              || GET_MODE (x7) != E_QQmode)
            return -1;
          return 0;

        case E_UQQmode:
          if (GET_MODE (x3) != E_UQQmode
              || GET_MODE (x4) != E_UQQmode
              || GET_MODE (x7) != E_UQQmode)
            return -1;
          return 1;

        case E_HQmode:
          if (GET_MODE (x3) != E_HQmode
              || GET_MODE (x4) != E_HQmode
              || GET_MODE (x7) != E_HQmode)
            return -1;
          return 2;

        case E_UHQmode:
          if (GET_MODE (x3) != E_UHQmode
              || GET_MODE (x4) != E_UHQmode
              || GET_MODE (x7) != E_UHQmode)
            return -1;
          return 3;

        case E_HAmode:
          if (GET_MODE (x3) != E_HAmode
              || GET_MODE (x4) != E_HAmode
              || GET_MODE (x7) != E_HAmode)
            return -1;
          return 4;

        case E_UHAmode:
          if (GET_MODE (x3) != E_UHAmode
              || GET_MODE (x4) != E_UHAmode
              || GET_MODE (x7) != E_UHAmode)
            return -1;
          return 5;

        default:
          return -1;
        }

    case 18:
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 22)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 18)
        return -1;
      switch (GET_MODE (x5))
        {
        case E_SQmode:
          if (GET_MODE (x3) != E_SQmode
              || GET_MODE (x4) != E_SQmode
              || GET_MODE (x7) != E_SQmode)
            return -1;
          return 6;

        case E_USQmode:
          if (GET_MODE (x3) != E_USQmode
              || GET_MODE (x4) != E_USQmode
              || GET_MODE (x7) != E_USQmode)
            return -1;
          return 7;

        case E_SAmode:
          if (GET_MODE (x3) != E_SAmode
              || GET_MODE (x4) != E_SAmode
              || GET_MODE (x7) != E_SAmode)
            return -1;
          return 8;

        case E_USAmode:
          if (GET_MODE (x3) != E_USAmode
              || GET_MODE (x4) != E_USAmode
              || GET_MODE (x7) != E_USAmode)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern331 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 22)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 26
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 30
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != 36
      || GET_MODE (x9) != E_CCmode)
    return -1;
  return pattern278 (x2); /* [-1, 1] */
}

int
pattern339 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  if (!const_1_to_3_operand (operands[4], E_QImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x11 = XEXP (x9, 1);
  operands[2] = x11;
  if (!const_1_to_3_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern343 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!pseudo_register_operand (operands[0], E_PSImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!pseudo_register_operand (operands[1], E_PSImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!pseudo_register_operand (operands[2], E_PSImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!pseudo_register_operand (operands[3], E_PSImode))
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != E_PSImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x9, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern353 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 36
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern357 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  if (!const_operand (operands[2], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern356 (x3); /* [-1, 0] */
}

int
pattern362 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern369 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern376 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern381 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UQQmode)
        return -1;
      return 2;

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      return 3;

    case E_HQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      return 4;

    case E_UHQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      return 5;

    case E_HAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      return 6;

    case E_UHAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      return 7;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 8;

    case E_SQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SQmode)
        return -1;
      return 9;

    case E_USQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USQmode)
        return -1;
      return 10;

    case E_SAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      return 11;

    case E_USAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      return 12;

    case E_SFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      return 13;

    case E_PSImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      return 14;

    default:
      return -1;
    }
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 2);
  operands[1] = x4;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x2, 0);
  switch (pattern232 (x6))
    {
    case 0:
      return 1076; /* *insv.io */

    case 1:
      return 1078; /* *insv.reg_split */

    default:
      return -1;
    }
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern129 (x2))
        {
        case 0:
          return 246; /* *subhi3.sign_extend.qi_split */

        case 1:
          return 248; /* *subpsi3.sign_extend.qi_split */

        case 2:
          return 252; /* *subpsi3.sign_extend.hi_split */

        case 3:
          return 250; /* *subsi3.sign_extend.qi_split */

        case 4:
          return 254; /* *subsi3.sign_extend.hi_split */

        case 5:
          return 256; /* *subsi3.sign_extend.psi_split */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern129 (x2))
        {
        case 0:
          return 247; /* *subhi3.zero_extend.qi_split */

        case 1:
          return 249; /* *subpsi3.zero_extend.qi_split */

        case 2:
          return 253; /* *subpsi3.zero_extend.hi_split */

        case 3:
          return 251; /* *subsi3.zero_extend.qi_split */

        case 4:
          return 255; /* *subsi3.zero_extend.hi_split */

        case 5:
          return 257; /* *subsi3.zero_extend.psi_split */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_PSImode:
          if (pattern194 (x2, 
E_PSImode) != 0)
            return -1;
          return 272; /* subpsi3 */

        case E_QImode:
          if (pattern217 (x2, 
E_QImode) != 0)
            return -1;
          return 274; /* subqi3 */

        case E_QQmode:
          if (pattern217 (x2, 
E_QQmode) != 0)
            return -1;
          return 275; /* subqq3 */

        case E_UQQmode:
          if (pattern217 (x2, 
E_UQQmode) != 0)
            return -1;
          return 276; /* subuqq3 */

        case E_HImode:
          if (pnum_clobbers == NULL
              || pattern217 (x2, 
E_HImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 280; /* subhi3 */

        case E_HQmode:
          if (pnum_clobbers == NULL
              || pattern217 (x2, 
E_HQmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 281; /* subhq3 */

        case E_UHQmode:
          if (pnum_clobbers == NULL
              || pattern217 (x2, 
E_UHQmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 282; /* subuhq3 */

        case E_HAmode:
          if (pnum_clobbers == NULL
              || pattern217 (x2, 
E_HAmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 283; /* subha3 */

        case E_UHAmode:
          if (pnum_clobbers == NULL
              || pattern217 (x2, 
E_UHAmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 284; /* subuha3 */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern217 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 290; /* subsi3 */

        case E_SQmode:
          if (pnum_clobbers == NULL
              || pattern217 (x2, 
E_SQmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 291; /* subsq3 */

        case E_USQmode:
          if (pnum_clobbers == NULL
              || pattern217 (x2, 
E_USQmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 292; /* subusq3 */

        case E_SAmode:
          if (pnum_clobbers == NULL
              || pattern217 (x2, 
E_SAmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 293; /* subsa3 */

        case E_USAmode:
          if (pnum_clobbers == NULL
              || pattern217 (x2, 
E_USAmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 294; /* subusa3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern130 (x2))
        {
        case 0:
          return 308; /* *subqi3.msbit_split */

        case 1:
          return 310; /* *subhi3.msbit_split */

        case 2:
          return 312; /* *subpsi3.msbit_split */

        case 3:
          return 314; /* *subsi3.msbit_split */

        case 4:
          return 336; /* *subhi3.sex.msbit_split */

        case 5:
          return 338; /* *subpsi3.sex.msbit_split */

        case 6:
          return 342; /* *subpsi3.sex.msbit_split */

        case 7:
          return 340; /* *subsi3.sex.msbit_split */

        case 8:
          return 344; /* *subsi3.sex.msbit_split */

        case 9:
          return 346; /* *subsi3.sex.msbit_split */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern130 (x2))
        {
        case 0:
          return 309; /* *subqi3.msbit_split */

        case 1:
          return 311; /* *subhi3.msbit_split */

        case 2:
          return 313; /* *subpsi3.msbit_split */

        case 3:
          return 315; /* *subsi3.msbit_split */

        case 4:
          return 337; /* *subhi3.sex.msbit_split */

        case 5:
          return 339; /* *subpsi3.sex.msbit_split */

        case 6:
          return 343; /* *subpsi3.sex.msbit_split */

        case 7:
          return 341; /* *subsi3.sex.msbit_split */

        case 8:
          return 345; /* *subsi3.sex.msbit_split */

        case 9:
          return 347; /* *subsi3.sex.msbit_split */

        default:
          return -1;
        }

    case GE:
      switch (pattern132 (x2))
        {
        case 0:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 348; /* *subqi3.ge0 */
            }
          return 444; /* *subqi3.ge0_split */

        case 1:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 356; /* *subqi3.ge0 */
            }
          return 452; /* *subqi3.ge0_split */

        case 2:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 364; /* *subqi3.ge0 */
            }
          return 460; /* *subqi3.ge0_split */

        case 3:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 372; /* *subqi3.ge0 */
            }
          return 468; /* *subqi3.ge0_split */

        case 4:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 350; /* *subhi3.ge0 */
            }
          return 446; /* *subhi3.ge0_split */

        case 5:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 358; /* *subhi3.ge0 */
            }
          return 454; /* *subhi3.ge0_split */

        case 6:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 366; /* *subhi3.ge0 */
            }
          return 462; /* *subhi3.ge0_split */

        case 7:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 374; /* *subhi3.ge0 */
            }
          return 470; /* *subhi3.ge0_split */

        case 8:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 352; /* *subpsi3.ge0 */
            }
          return 448; /* *subpsi3.ge0_split */

        case 9:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 360; /* *subpsi3.ge0 */
            }
          return 456; /* *subpsi3.ge0_split */

        case 10:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 368; /* *subpsi3.ge0 */
            }
          return 464; /* *subpsi3.ge0_split */

        case 11:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 376; /* *subpsi3.ge0 */
            }
          return 472; /* *subpsi3.ge0_split */

        case 12:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 354; /* *subsi3.ge0 */
            }
          return 450; /* *subsi3.ge0_split */

        case 13:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 362; /* *subsi3.ge0 */
            }
          return 458; /* *subsi3.ge0_split */

        case 14:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 370; /* *subsi3.ge0 */
            }
          return 466; /* *subsi3.ge0_split */

        case 15:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 378; /* *subsi3.ge0 */
            }
          return 474; /* *subsi3.ge0_split */

        default:
          return -1;
        }

    case LT:
      switch (pattern132 (x2))
        {
        case 0:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 349; /* *subqi3.lt0 */
            }
          return 445; /* *subqi3.lt0_split */

        case 1:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 357; /* *subqi3.lt0 */
            }
          return 453; /* *subqi3.lt0_split */

        case 2:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 365; /* *subqi3.lt0 */
            }
          return 461; /* *subqi3.lt0_split */

        case 3:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 373; /* *subqi3.lt0 */
            }
          return 469; /* *subqi3.lt0_split */

        case 4:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 351; /* *subhi3.lt0 */
            }
          return 447; /* *subhi3.lt0_split */

        case 5:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 359; /* *subhi3.lt0 */
            }
          return 455; /* *subhi3.lt0_split */

        case 6:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 367; /* *subhi3.lt0 */
            }
          return 463; /* *subhi3.lt0_split */

        case 7:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 375; /* *subhi3.lt0 */
            }
          return 471; /* *subhi3.lt0_split */

        case 8:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 353; /* *subpsi3.lt0 */
            }
          return 449; /* *subpsi3.lt0_split */

        case 9:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 361; /* *subpsi3.lt0 */
            }
          return 457; /* *subpsi3.lt0_split */

        case 10:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 369; /* *subpsi3.lt0 */
            }
          return 465; /* *subpsi3.lt0_split */

        case 11:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 377; /* *subpsi3.lt0 */
            }
          return 473; /* *subpsi3.lt0_split */

        case 12:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 355; /* *subsi3.lt0 */
            }
          return 451; /* *subsi3.lt0_split */

        case 13:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 363; /* *subsi3.lt0 */
            }
          return 459; /* *subsi3.lt0_split */

        case 14:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 371; /* *subsi3.lt0 */
            }
          return 467; /* *subsi3.lt0_split */

        case 15:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 379; /* *subsi3.lt0 */
            }
          return 475; /* *subsi3.lt0_split */

        default:
          return -1;
        }

    case MULT:
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (pattern192 (x2) != 0)
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2622 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 492; /* *msubqi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2637 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 493; /* *msubqi4 */

            case CONST_INT:
              if (pnum_clobbers == NULL
                  || !const_int_operand (operands[2], E_QImode)
                  || !
#line 2666 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              *pnum_clobbers = 1;
              return 495; /* *msubqi4.const */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern193 (x2) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2734 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 500; /* *msubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2749 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 502; /* *msubqihi4 */

            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2798 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return 509; /* *sumsubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2815 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              *pnum_clobbers = 1;
              return 511; /* *sumsubqihi4 */

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x6;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2881 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 515; /* *msubqihi4.sconst */
                }
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2972 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              *pnum_clobbers = 1;
              return 520; /* *sumsubqihi4.uconst */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern193 (x2) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2734 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 501; /* *umsubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2749 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 503; /* *umsubqihi4 */

            case SIGN_EXTEND:
              if (GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2798 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return 508; /* *usmsubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2815 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return -1;
              *pnum_clobbers = 1;
              return 510; /* *usmsubqihi4 */

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x6;
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2881 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              *pnum_clobbers = 1;
              return 516; /* *umsubqihi4.uconst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      if (!register_operand (operands[3], E_HImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_QImode)
              || !const_2_to_7_operand (operands[2], E_HImode)
              || !
#line 2904 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 517; /* *umsubqihi4.uconst.ashift */

        case SIGN_EXTEND:
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_QImode)
              || !const_1_to_6_operand (operands[2], E_HImode)
              || !
#line 2928 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 518; /* *msubqihi4.sconst.ashift */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      switch (pattern54 (x1, pnum_clobbers))
        {
        case 0:
          return 705; /* ashrqi3 */

        case 1:
          return 706; /* ashrqq3 */

        case 2:
          return 707; /* ashruqq3 */

        case 3:
          if (nop_general_operand (operands[2], E_QImode))
            return 711; /* ashrhi3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5931 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 733; /* *ashrhi3_const */
            }
          break;

        case 4:
          if (nop_general_operand (operands[2], E_QImode))
            return 712; /* ashrhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5931 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 734; /* *ashrhq3_const */
            }
          break;

        case 5:
          if (nop_general_operand (operands[2], E_QImode))
            return 713; /* ashruhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5931 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 735; /* *ashruhq3_const */
            }
          break;

        case 6:
          if (nop_general_operand (operands[2], E_QImode))
            return 714; /* ashrha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5931 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 736; /* *ashrha3_const */
            }
          break;

        case 7:
          if (nop_general_operand (operands[2], E_QImode))
            return 715; /* ashruha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5931 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 737; /* *ashruha3_const */
            }
          break;

        case 8:
          *pnum_clobbers = 1;
          return 721; /* ashrpsi3 */

        case 9:
          return 723; /* ashrsi3 */

        case 10:
          return 724; /* ashrsq3 */

        case 11:
          return 725; /* ashrusq3 */

        case 12:
          return 726; /* ashrsa3 */

        case 13:
          return 727; /* ashrusa3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      if (pattern55 (x1) == 0)
        return 1083; /* *insv.shiftrt */
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  switch (pattern87 (x1))
    {
    case 0:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3305; /* ashrdi3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3333; /* *ashrdi3_insn */

    case 1:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3309; /* ashrdq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3337; /* *ashrdq3_insn */

    case 2:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3313; /* ashrudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3341; /* *ashrudq3_insn */

    case 3:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3317; /* ashrda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3345; /* *ashrda3_insn */

    case 4:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3321; /* ashruda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3349; /* *ashruda3_insn */

    case 5:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3325; /* ashrta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3353; /* *ashrta3_insn */

    case 6:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3329; /* ashruta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3357; /* *ashruta3_insn */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_18 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 18)
        return -1;
      switch (pattern87 (x1))
        {
        case 0:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3307; /* rotldi3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3335; /* *rotldi3_insn */

        case 1:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3311; /* rotldq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3339; /* *rotldq3_insn */

        case 2:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3315; /* rotludq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3343; /* *rotludq3_insn */

        case 3:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3319; /* rotlda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3347; /* *rotlda3_insn */

        case 4:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3323; /* rotluda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3351; /* *rotluda3_insn */

        case 5:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3327; /* rotlta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3355; /* *rotlta3_insn */

        case 6:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3331; /* rotluta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3359; /* *rotluta3_insn */

        default:
          return -1;
        }

    case CONST_INT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      switch (XWINT (x3, 0))
        {
        case 1L:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_QImode)
              || !
#line 9015 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1014; /* *mask1_0x01 */

        case -2L:
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              if (GET_MODE (x5) != E_QImode)
                return -1;
              x6 = XEXP (x5, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
                return -1;
              x7 = XEXP (x5, 0);
              operands[1] = x7;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 1018; /* mask1_0xfe_split */

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode)
                  || !
#line 9091 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 1019; /* *mask1_0xfe */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) == REG
          && REGNO (x7) == 36
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern108 (x4, 
E_QImode) == 0
                  && 
#line 1594 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 177; /* *addqi3 */
              break;

            case E_QQmode:
              if (pattern108 (x4, 
E_QQmode) == 0
                  && 
#line 1594 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 178; /* *addqq3 */
              break;

            case E_UQQmode:
              if (pattern108 (x4, 
E_UQQmode) == 0
                  && 
#line 1594 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 179; /* *adduqq3 */
              break;

            case E_HImode:
              if (pattern315 (x4, 
E_HImode) == 0
                  && 
#line 1852 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 199; /* *addhi3 */
              break;

            case E_HQmode:
              if (pattern315 (x4, 
E_HQmode) == 0
                  && 
#line 1852 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 200; /* *addhq3 */
              break;

            case E_UHQmode:
              if (pattern315 (x4, 
E_UHQmode) == 0
                  && 
#line 1852 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 201; /* *adduhq3 */
              break;

            case E_HAmode:
              if (pattern315 (x4, 
E_HAmode) == 0
                  && 
#line 1852 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 202; /* *addha3 */
              break;

            case E_UHAmode:
              if (pattern315 (x4, 
E_UHAmode) == 0
                  && 
#line 1852 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 203; /* *adduha3 */
              break;

            default:
              break;
            }
        }
      operands[3] = x7;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern314 (x4, 
E_HImode) != 0)
            return -1;
          return 204; /* addhi3_clobber */

        case E_HQmode:
          if (pattern314 (x4, 
E_HQmode) != 0)
            return -1;
          return 205; /* addhq3_clobber */

        case E_UHQmode:
          if (pattern314 (x4, 
E_UHQmode) != 0)
            return -1;
          return 206; /* adduhq3_clobber */

        case E_HAmode:
          if (pattern314 (x4, 
E_HAmode) != 0)
            return -1;
          return 207; /* addha3_clobber */

        case E_UHAmode:
          if (pattern314 (x4, 
E_UHAmode) != 0)
            return -1;
          return 208; /* adduha3_clobber */

        case E_SImode:
          if (pattern108 (x4, 
E_SImode) != 0)
            return -1;
          return 214; /* addsi3 */

        case E_SQmode:
          if (pattern108 (x4, 
E_SQmode) != 0)
            return -1;
          return 215; /* addsq3 */

        case E_USQmode:
          if (pattern108 (x4, 
E_USQmode) != 0)
            return -1;
          return 216; /* addusq3 */

        case E_SAmode:
          if (pattern108 (x4, 
E_SAmode) != 0)
            return -1;
          return 217; /* addsa3 */

        case E_USAmode:
          if (pattern108 (x4, 
E_USAmode) != 0)
            return -1;
          return 218; /* addusa3 */

        case E_PSImode:
          if (pattern108 (x4, 
E_PSImode) != 0)
            return -1;
          return 270; /* addpsi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode
          || pattern267 (x1, 
E_HImode) != 0)
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 1676 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 183; /* *addhi3_zero_extend1 */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x5, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !nonmemory_operand (operands[1], E_HImode)
          || !
#line 6858 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 864; /* cmphi3 */

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || !nonmemory_operand (operands[1], E_HQmode)
          || !
#line 6858 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 865; /* cmphq3 */

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || !nonmemory_operand (operands[1], E_UHQmode)
          || !
#line 6858 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 866; /* cmpuhq3 */

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || !nonmemory_operand (operands[1], E_HAmode)
          || !
#line 6858 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 867; /* cmpha3 */

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || !nonmemory_operand (operands[1], E_UHAmode)
          || !
#line 6858 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 868; /* cmpuha3 */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !nonmemory_operand (operands[1], E_PSImode)
          || !
#line 6893 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 869; /* *cmppsi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !nonmemory_operand (operands[1], E_SImode)
          || !
#line 6925 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 870; /* *cmpsi */

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !nonmemory_operand (operands[1], E_SQmode)
          || !
#line 6925 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 871; /* *cmpsq */

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !nonmemory_operand (operands[1], E_USQmode)
          || !
#line 6925 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 872; /* *cmpusq */

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !nonmemory_operand (operands[1], E_SAmode)
          || !
#line 6925 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 873; /* *cmpsa */

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !nonmemory_operand (operands[1], E_USAmode)
          || !
#line 6925 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 874; /* *cmpusa */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[0] = x4;
      if (ordered_comparison_operator (operands[0], E_VOIDmode))
        {
          res = recog_52 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x3, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (pattern100 (x9, 
36, 
E_CCmode) != 0)
        return -1;
      switch (GET_CODE (operands[0]))
        {
        case NE:
        case EQ:
          if (!eqne_operator (operands[0], E_VOIDmode))
            return -1;
          x10 = XEXP (x6, 0);
          operands[3] = x10;
          x11 = XEXP (x4, 0);
          switch (GET_CODE (x11))
            {
            case ZERO_EXTRACT:
              x12 = XEXP (x11, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x13 = XEXP (x11, 2);
              operands[2] = x13;
              if (!const_int_operand (operands[2], E_VOIDmode))
                return -1;
              x14 = XEXP (x11, 0);
              switch (GET_CODE (x14))
                {
                case REG:
                case SUBREG:
                  operands[1] = x14;
                  if (!register_operand (operands[1], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (x11))
                    {
                    case E_QImode:
                      if (!
#line 7695 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 953; /* *sbrx_branchqi */

                    case E_HImode:
                      if (!
#line 7695 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 954; /* *sbrx_branchhi */

                    case E_PSImode:
                      if (!
#line 7695 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 955; /* *sbrx_branchpsi */

                    case E_SImode:
                      if (!
#line 7695 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 956; /* *sbrx_branchsi */

                    case E_DImode:
                      if (!
#line 7695 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 957; /* *sbrx_branchdi */

                    default:
                      return -1;
                    }

                case MEM:
                  if (GET_MODE (x14) != E_QImode)
                    return -1;
                  x15 = XEXP (x14, 0);
                  operands[1] = x15;
                  switch (GET_MODE (x11))
                    {
                    case E_QImode:
                      if (low_io_address_operand (operands[1], E_VOIDmode)
                          && 
#line 8209 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return 984; /* *sbix_branch */
                      if (!high_io_address_operand (operands[1], E_VOIDmode)
                          || !
#line 8304 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 990; /* *sbix_branch_tmp */

                    case E_HImode:
                      if (low_io_address_operand (operands[1], E_VOIDmode)
                          && 
#line 8209 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return 985; /* *sbix_branch */
                      if (!high_io_address_operand (operands[1], E_VOIDmode)
                          || !
#line 8304 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 991; /* *sbix_branch_tmp */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case AND:
              x14 = XEXP (x11, 0);
              operands[1] = x14;
              x12 = XEXP (x11, 1);
              operands[2] = x12;
              switch (GET_MODE (x11))
                {
                case E_QImode:
                  if (!register_operand (operands[1], E_QImode)
                      || !single_one_operand (operands[2], E_QImode)
                      || !
#line 7743 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 962; /* *sbrx_and_branchqi */

                case E_HImode:
                  if (!register_operand (operands[1], E_HImode)
                      || !single_one_operand (operands[2], E_HImode)
                      || !
#line 7743 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 963; /* *sbrx_and_branchhi */

                case E_PSImode:
                  if (!register_operand (operands[1], E_PSImode)
                      || !single_one_operand (operands[2], E_PSImode)
                      || !
#line 7743 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 964; /* *sbrx_and_branchpsi */

                case E_SImode:
                  if (!register_operand (operands[1], E_SImode)
                      || !single_one_operand (operands[2], E_SImode)
                      || !
#line 7743 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 965; /* *sbrx_and_branchsi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GE:
        case LT:
          if (!gelt_operator (operands[0], E_VOIDmode))
            return -1;
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_QImode)
            return -1;
          x14 = XEXP (x11, 0);
          operands[1] = x14;
          x10 = XEXP (x6, 0);
          operands[2] = x10;
          if (low_io_address_operand (operands[1], E_VOIDmode)
              && 
#line 8251 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 987; /* *sbix_branch_bit7 */
          if (!high_io_address_operand (operands[1], E_VOIDmode)
              || !
#line 8345 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 993; /* *sbix_branch_tmp_bit7 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != ZERO_EXTEND
          || GET_MODE (x6) != E_HImode
          || pattern169 (x1, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 1787 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 192; /* *udiff_widenqihi3 */

    case REG:
    case SUBREG:
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      res = recog_42 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG
          || pattern206 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
          switch (pattern337 (x3))
            {
            case 0:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3203; /* *subdi3_insn */

            case 1:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3204; /* *subdq3_insn */

            case 2:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3205; /* *subudq3_insn */

            case 3:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3206; /* *subda3_insn */

            case 4:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3207; /* *subuda3_insn */

            case 5:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3208; /* *subta3_insn */

            case 6:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3209; /* *subuta3_insn */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
          switch (pattern338 (x3))
            {
            case 0:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3217; /* *subdi3_const_insn */

            case 1:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3218; /* *subdq3_const_insn */

            case 2:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3219; /* *subudq3_const_insn */

            case 3:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3220; /* *subda3_const_insn */

            case 4:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3221; /* *subuda3_const_insn */

            case 5:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3222; /* *subta3_const_insn */

            case 6:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3223; /* *subuta3_const_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_71 (x1, insn, pnum_clobbers);

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!nonmemory_operand (operands[0], E_HImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!general_operand (operands[1], E_HImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      return 970; /* call_insn */

    case UNSPEC_VOLATILE:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x8 = XEXP (x4, 1);
      if (pattern103 (x8) != 0)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          switch (XINT (x2, 1))
            {
            case 5:
              x9 = XVECEXP (x2, 0, 0);
              operands[0] = x9;
              if (!const_int_operand (operands[0], E_QImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              x10 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              return 995; /* cli_sei */

            case 7:
              x9 = XVECEXP (x2, 0, 0);
              operands[0] = x9;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              x10 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              return 1054; /* *nopv */

            case 8:
              x9 = XVECEXP (x2, 0, 0);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x7 = XEXP (x4, 0);
              operands[0] = x7;
              x10 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x10, operands[0]))
                return -1;
              return 1055; /* *sleep */

            case 9:
              x9 = XVECEXP (x2, 0, 0);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x7 = XEXP (x4, 0);
              operands[0] = x7;
              x10 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x10, operands[0]))
                return -1;
              return 1056; /* *wdr */

            default:
              return -1;
            }

        case 2:
          if (pnum_clobbers == NULL
              || XINT (x2, 1) != 10)
            return -1;
          x11 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          x9 = XVECEXP (x2, 0, 0);
          operands[0] = x9;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          x10 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (XWINT (x11, 0))
            {
            case 1L:
              if (!const_int_operand (operands[0], E_QImode))
                return -1;
              *pnum_clobbers = 1;
              return 1003; /* delay_cycles_1 */

            case 2L:
              if (!const_int_operand (operands[0], E_HImode))
                return -1;
              *pnum_clobbers = 1;
              return 1005; /* delay_cycles_2 */

            case 3L:
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              *pnum_clobbers = 3;
              return 1007; /* delay_cycles_3 */

            case 4L:
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              *pnum_clobbers = 4;
              return 1009; /* delay_cycles_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern105 (x1) != 0
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern314 (x3, 
E_HImode) != 0
          || !
#line 1927 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 209; /* *addhi3_clobber */

    case E_HQmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern314 (x3, 
E_HQmode) != 0
          || !
#line 1927 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 210; /* *addhq3_clobber */

    case E_UHQmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern314 (x3, 
E_UHQmode) != 0
          || !
#line 1927 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 211; /* *adduhq3_clobber */

    case E_HAmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern314 (x3, 
E_HAmode) != 0
          || !
#line 1927 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 212; /* *addha3_clobber */

    case E_UHAmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern314 (x3, 
E_UHAmode) != 0
          || !
#line 1927 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 213; /* *adduha3_clobber */

    case E_SImode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_SImode) != 0
          || !
#line 1958 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 219; /* *addsi3 */

    case E_SQmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_SQmode) != 0
          || !
#line 1958 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 220; /* *addsq3 */

    case E_USQmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_USQmode) != 0
          || !
#line 1958 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 221; /* *addusq3 */

    case E_SAmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_SAmode) != 0
          || !
#line 1958 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 222; /* *addsa3 */

    case E_USAmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_USAmode) != 0
          || !
#line 1958 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 223; /* *addusa3 */

    case E_PSImode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_PSImode) != 0
          || !
#line 2068 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 271; /* *addpsi3 */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
          if (XWINT (x3, 0) != 0L)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_BLKmode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != USE)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != USE)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x8) != CLOBBER)
            return -1;
          switch (pattern294 (x1))
            {
            case 0:
              return 168; /* *clrmemqi_split */

            case 1:
              return 170; /* *clrmemhi_split */

            default:
              return -1;
            }

        case MULT:
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != REG
              || pattern149 (x2) != 0
              || pattern106 (x1) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x10 = XEXP (x7, 0);
          if (GET_CODE (x10) != REG
              || GET_MODE (x10) != E_HImode)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (pattern176 (x8) != 0)
            return -1;
          switch (pattern367 (x1))
            {
            case 0:
              if (!
#line 3766 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && reload_completed))
                return -1;
              return 567; /* *mulsi3_call_pr118012 */

            case 1:
              if (!
#line 4272 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 605; /* *mulpsi3.libgcc */

            default:
              return -1;
            }

        case DIV:
          switch (pattern118 (x1, 
MOD))
            {
            case 0:
              x11 = XEXP (x3, 1);
              if (REGNO (x11) != 22)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x5, 1);
              x13 = XEXP (x12, 0);
              if (REGNO (x13) != 24)
                return -1;
              x14 = XEXP (x12, 1);
              if (REGNO (x14) != 22)
                return -1;
              x8 = XVECEXP (x1, 0, 4);
              x15 = XEXP (x8, 0);
              if (REGNO (x15) != 36
                  || GET_MODE (x15) != E_CCmode)
                return -1;
              switch (pattern380 (x1))
                {
                case 0:
                  if (!
#line 3940 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 586; /* *divmodqi4_call */

                case 1:
                  if (!
#line 4028 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 592; /* *divmodhi4_call */

                default:
                  return -1;
                }

            case 1:
              switch (pattern374 (x1))
                {
                case 0:
                  return 607; /* *divmodpsi4_call_split */

                case 1:
                  if (!
#line 4426 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 614; /* *divmodsi4_call */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UDIV:
          switch (pattern118 (x1, 
UMOD))
            {
            case 0:
              if (pattern368 (x1, 
E_HImode, 
22, 
24) != 0)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              x16 = XEXP (x5, 0);
              if (REGNO (x16) != 24
                  || GET_MODE (x16) != E_HImode)
                return -1;
              x6 = XVECEXP (x1, 0, 2);
              x17 = XEXP (x6, 0);
              if (REGNO (x17) != 26
                  || GET_MODE (x17) != E_HImode)
                return -1;
              x7 = XVECEXP (x1, 0, 3);
              x10 = XEXP (x7, 0);
              if (REGNO (x10) != 21
                  || GET_MODE (x10) != E_QImode)
                return -1;
              x8 = XVECEXP (x1, 0, 4);
              x15 = XEXP (x8, 0);
              if (REGNO (x15) != 36
                  || GET_MODE (x15) != E_CCmode
                  || GET_MODE (x3) != E_HImode)
                return -1;
              x12 = XEXP (x5, 1);
              if (GET_MODE (x12) != E_HImode
                  || !
#line 4075 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 595; /* *udivmodhi4_call */

            case 1:
              switch (pattern374 (x1))
                {
                case 0:
                  return 610; /* *udivmodpsi4_call_split */

                case 1:
                  if (!
#line 4473 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 617; /* *udivmodsi4_call */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (pattern119 (x1) != 0
              || pattern177 (x1, 
CLOBBER) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          x10 = XEXP (x7, 0);
          if (x10 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x18 = XVECEXP (x3, 0, 0);
              operands[0] = x18;
              if (register_operand (operands[0], E_HImode))
                {
                  x5 = XVECEXP (x1, 0, 1);
                  x16 = XEXP (x5, 0);
                  x19 = XEXP (x16, 0);
                  operands[1] = x19;
                  x6 = XVECEXP (x1, 0, 2);
                  x17 = XEXP (x6, 0);
                  operands[2] = x17;
                  if (scratch_operand (operands[2], E_HImode)
                      && 
#line 7989 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL && reload_completed))
                    return 975; /* *tablejump */
                }
            }
          x18 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x18) != REG
              || pattern332 (x1) != 0
              || !
#line 8026 "../../gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL && reload_completed))
            return -1;
          return 977; /* *tablejump.3byte-pc */

        case SIGN_EXTEND:
        case ZERO_EXTEND:
          operands[10] = x3;
          if (!extend_operator (operands[10], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != PARALLEL
              || XVECLEN (x5, 0) != 2)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x20) != SET)
            return -1;
          x21 = XEXP (x20, 1);
          if (GET_CODE (x21) != PLUS
              || GET_MODE (x21) != E_SImode)
            return -1;
          x22 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x22) != CLOBBER)
            return -1;
          x23 = XEXP (x22, 0);
          if (GET_CODE (x23) != SCRATCH
              || GET_MODE (x23) != E_QImode)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 2)
            return -1;
          x24 = XVECEXP (x6, 0, 0);
          if (GET_CODE (x24) != SET)
            return -1;
          x25 = XEXP (x24, 1);
          if (GET_CODE (x25) != IF_THEN_ELSE)
            return -1;
          x26 = XEXP (x25, 0);
          if (GET_CODE (x26) != GTU)
            return -1;
          x27 = XEXP (x25, 1);
          if (GET_CODE (x27) != LABEL_REF)
            return -1;
          x28 = XEXP (x25, 2);
          if (GET_CODE (x28) != PC)
            return -1;
          x29 = XEXP (x24, 0);
          if (GET_CODE (x29) != PC)
            return -1;
          x30 = XVECEXP (x6, 0, 1);
          if (GET_CODE (x30) != CLOBBER)
            return -1;
          x31 = XEXP (x30, 0);
          if (GET_CODE (x31) != SCRATCH
              || GET_MODE (x31) != E_QImode)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != SET)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x8) != PARALLEL
              || XVECLEN (x8, 0) != 4)
            return -1;
          x32 = XVECEXP (x8, 0, 0);
          if (GET_CODE (x32) != SET)
            return -1;
          x33 = XEXP (x32, 1);
          if (GET_CODE (x33) != UNSPEC
              || XVECLEN (x33, 0) != 1
              || XINT (x33, 1) != 2
              || GET_MODE (x33) != E_HImode)
            return -1;
          x34 = XEXP (x32, 0);
          if (GET_CODE (x34) != PC)
            return -1;
          x35 = XVECEXP (x8, 0, 1);
          if (GET_CODE (x35) != USE)
            return -1;
          x36 = XEXP (x35, 0);
          if (GET_CODE (x36) != LABEL_REF)
            return -1;
          x37 = XVECEXP (x8, 0, 2);
          if (GET_CODE (x37) != CLOBBER)
            return -1;
          x38 = XVECEXP (x8, 0, 3);
          if (GET_CODE (x38) != CLOBBER)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x3, 0);
          operands[11] = x9;
          x39 = XEXP (x20, 0);
          operands[5] = x39;
          if (!register_operand (operands[5], E_SImode))
            return -1;
          x40 = XEXP (x21, 1);
          operands[1] = x40;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x41 = XEXP (x26, 1);
          operands[2] = x41;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x42 = XEXP (x27, 0);
          operands[4] = x42;
          x10 = XEXP (x7, 0);
          operands[7] = x10;
          if (!register_operand (operands[7], E_HImode))
            return -1;
          x43 = XEXP (x7, 1);
          operands[6] = x43;
          x44 = XEXP (x36, 0);
          operands[3] = x44;
          x45 = XEXP (x37, 0);
          operands[8] = x45;
          x46 = XEXP (x38, 0);
          operands[9] = x46;
          x47 = XEXP (x21, 0);
          if (!rtx_equal_p (x47, operands[0]))
            return -1;
          x48 = XEXP (x26, 0);
          if (!rtx_equal_p (x48, operands[5]))
            return -1;
          x49 = XVECEXP (x33, 0, 0);
          if (!rtx_equal_p (x49, operands[7]))
            return -1;
          switch (GET_MODE (operands[11]))
            {
            case E_QImode:
              if (!register_operand (operands[11], E_QImode)
                  || !
#line 8139 "../../gcc/config/avr/avr.md"
(optimize
   && avr_casei_sequence_check_operands (operands)))
                return -1;
              return 978; /* casesi_qi_sequence */

            case E_HImode:
              if (!register_operand (operands[11], E_HImode)
                  || !
#line 8139 "../../gcc/config/avr/avr.md"
(optimize
   && avr_casei_sequence_check_operands (operands)))
                return -1;
              return 979; /* casesi_hi_sequence */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x7 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (pattern175 (x1) != 0
              || pattern189 (x1, 
E_CCmode, 
36, 
30) != 0)
            return -1;
          x12 = XEXP (x5, 1);
          x14 = XEXP (x12, 1);
          operands[0] = x14;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          x50 = XEXP (x6, 1);
          x51 = XEXP (x50, 1);
          if (!rtx_equal_p (x51, operands[0]))
            return -1;
          return 997; /* epilogue_restores */

        case 2:
          if (XINT (x2, 1) != 10)
            return -1;
          x52 = XVECEXP (x2, 0, 1);
          if (x52 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || pattern254 (x1) != 0)
            return -1;
          return 1007; /* delay_cycles_3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT)
    {
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 0);
      if (rtx_equal_p (x5, operands[0]))
        {
          switch (XWINT (x3, 0))
            {
            case 4L:
              switch (pattern179 (x2))
                {
                case 0:
                  return gen_split_420 (insn, operands);

                case 1:
                  return gen_split_421 (insn, operands);

                case 2:
                  return gen_split_422 (insn, operands);

                default:
                  break;
                }
              break;

            case 5L:
              switch (pattern179 (x2))
                {
                case 0:
                  return gen_split_423 (insn, operands);

                case 1:
                  return gen_split_424 (insn, operands);

                case 2:
                  return gen_split_425 (insn, operands);

                default:
                  break;
                }
              break;

            case 6L:
              switch (pattern179 (x2))
                {
                case 0:
                  return gen_split_426 (insn, operands);

                case 1:
                  return gen_split_427 (insn, operands);

                case 2:
                  return gen_split_428 (insn, operands);

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
    }
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 18)
    return NULL;
  switch (pattern87 (x1))
    {
    case 0:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1947 (insn, operands);

    case 1:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1951 (insn, operands);

    case 2:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1955 (insn, operands);

    case 3:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1959 (insn, operands);

    case 4:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1963 (insn, operands);

    case 5:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1967 (insn, operands);

    case 6:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1971 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x4 = XEXP (x1, 0);
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (pattern123 (x1, 
E_QImode) == 0
                  && 
#line 1583 "../../gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_99 (insn, operands);
              break;

            case E_QQmode:
              if (pattern123 (x1, 
E_QQmode) == 0
                  && 
#line 1583 "../../gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_100 (insn, operands);
              break;

            case E_UQQmode:
              if (pattern123 (x1, 
E_UQQmode) == 0
                  && 
#line 1583 "../../gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_101 (insn, operands);
              break;

            case E_HImode:
              if (GET_MODE (x2) == E_HImode)
                {
                  operands[1] = x4;
                  if (stack_register_operand (operands[1], E_HImode))
                    {
                      x5 = XEXP (x2, 0);
                      operands[2] = x5;
                      if (stack_register_operand (operands[2], E_HImode))
                        {
                          operands[0] = x3;
                          if (avr_sp_immediate_operand (operands[0], E_HImode))
                            return gen_split_108 (insn, operands);
                        }
                    }
                  operands[0] = x4;
                  if (register_operand (operands[0], E_HImode))
                    {
                      x5 = XEXP (x2, 0);
                      operands[1] = x5;
                      if (register_operand (operands[1], E_HImode))
                        {
                          operands[2] = x3;
                          if (nonmemory_or_const_operand (operands[2], E_HImode))
                            return gen_split_109 (insn, operands);
                        }
                    }
                }
              break;

            case E_HQmode:
              if (pattern150 (x1, 
E_HQmode) == 0)
                return gen_split_110 (insn, operands);
              break;

            case E_UHQmode:
              if (pattern150 (x1, 
E_UHQmode) == 0)
                return gen_split_111 (insn, operands);
              break;

            case E_HAmode:
              if (pattern150 (x1, 
E_HAmode) == 0)
                return gen_split_112 (insn, operands);
              break;

            case E_UHAmode:
              if (pattern150 (x1, 
E_UHAmode) == 0)
                return gen_split_113 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case ZERO_EXTEND:
          if (pattern68 (x1) == 0
              && 
#line 1665 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_103 (insn, operands);
          break;

        default:
          break;
        }
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG)
        return NULL;
      switch (pattern71 (x1))
        {
        case 0:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1878 (insn, operands);

        case 1:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1879 (insn, operands);

        case 2:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1880 (insn, operands);

        case 3:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1881 (insn, operands);

        case 4:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1882 (insn, operands);

        case 5:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1883 (insn, operands);

        case 6:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1884 (insn, operands);

        case 7:
          if (!(
#line 122 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 124 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1885 (insn, operands);

        case 8:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1886 (insn, operands);

        case 9:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1887 (insn, operands);

        case 10:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1888 (insn, operands);

        case 11:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1889 (insn, operands);

        case 12:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1890 (insn, operands);

        case 13:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1891 (insn, operands);

        case 14:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1892 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern3 (x2))
            {
            case 0:
              if (!
#line 1642 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_102 (insn, operands);

            case 1:
              if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(3 > 1
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_126 (insn, operands);

            case 2:
              if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(3 > 2
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_130 (insn, operands);

            case 3:
              if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(4 > 1
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_128 (insn, operands);

            case 4:
              if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(4 > 2
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_132 (insn, operands);

            case 5:
              if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(4 > 3
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_134 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
          operands[2] = x3;
          if (!const_m255_to_m1_operand (operands[2], E_HImode)
              || pattern191 (x2) != 0
              || !
#line 1686 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_104 (insn, operands);

        case ZERO_EXTEND:
          if (pattern161 (x2) != 0
              || !
#line 1754 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_106 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (!
#line 1725 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_105 (insn, operands);

    case 3:
      if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_923 (insn, operands);

    case 4:
      if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_929 (insn, operands);

    case 5:
      if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_941 (insn, operands);

    case 6:
      if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_935 (insn, operands);

    case 7:
      if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_947 (insn, operands);

    case 8:
      if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_953 (insn, operands);

    case 9:
      if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_922 (insn, operands);

    case 10:
      if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_928 (insn, operands);

    case 11:
      if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_940 (insn, operands);

    case 12:
      if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_934 (insn, operands);

    case 13:
      if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_946 (insn, operands);

    case 14:
      if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_952 (insn, operands);

    case 15:
      if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(2 > 1
   && (2 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_124 (insn, operands);

    case 16:
      if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(3 > 1
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_125 (insn, operands);

    case 17:
      if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(3 > 2
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_129 (insn, operands);

    case 18:
      if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(4 > 1
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_127 (insn, operands);

    case 19:
      if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(4 > 2
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_131 (insn, operands);

    case 20:
      if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(4 > 3
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_133 (insn, operands);

    case 21:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_174 (insn, operands);

    case 22:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_176 (insn, operands);

    case 23:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_178 (insn, operands);

    case 24:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_180 (insn, operands);

    case 25:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_182 (insn, operands);

    case 26:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_184 (insn, operands);

    case 27:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_188 (insn, operands);

    case 28:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_186 (insn, operands);

    case 29:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_190 (insn, operands);

    case 30:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_192 (insn, operands);

    case 31:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_175 (insn, operands);

    case 32:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_177 (insn, operands);

    case 33:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_179 (insn, operands);

    case 34:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_181 (insn, operands);

    case 35:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_183 (insn, operands);

    case 36:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_185 (insn, operands);

    case 37:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_189 (insn, operands);

    case 38:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_187 (insn, operands);

    case 39:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_191 (insn, operands);

    case 40:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_193 (insn, operands);

    case 41:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_206 (insn, operands);

    case 42:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_214 (insn, operands);

    case 43:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_222 (insn, operands);

    case 44:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_230 (insn, operands);

    case 45:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_208 (insn, operands);

    case 46:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_216 (insn, operands);

    case 47:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_224 (insn, operands);

    case 48:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_232 (insn, operands);

    case 49:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_210 (insn, operands);

    case 50:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_218 (insn, operands);

    case 51:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_226 (insn, operands);

    case 52:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_234 (insn, operands);

    case 53:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_212 (insn, operands);

    case 54:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_220 (insn, operands);

    case 55:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_228 (insn, operands);

    case 56:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_236 (insn, operands);

    case 57:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_207 (insn, operands);

    case 58:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_215 (insn, operands);

    case 59:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_223 (insn, operands);

    case 60:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_231 (insn, operands);

    case 61:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_209 (insn, operands);

    case 62:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_217 (insn, operands);

    case 63:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_225 (insn, operands);

    case 64:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_233 (insn, operands);

    case 65:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_211 (insn, operands);

    case 66:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_219 (insn, operands);

    case 67:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_227 (insn, operands);

    case 68:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_235 (insn, operands);

    case 69:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_213 (insn, operands);

    case 70:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_221 (insn, operands);

    case 71:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_229 (insn, operands);

    case 72:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_237 (insn, operands);

    case 73:
      x2 = XEXP (x1, 1);
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[3] = x3;
      if (!register_operand (operands[3], E_QImode)
          || !(
#line 2596 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2598 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_277 (insn, operands);

    case 74:
      x2 = XEXP (x1, 1);
      switch (pattern126 (x2))
        {
        case 0:
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          if (GET_MODE (x7) != E_HImode
              || !register_operand (operands[3], E_HImode))
            return NULL;
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2705 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2707 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_281 (insn, operands);

            case ZERO_EXTEND:
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2763 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND) && 
#line 2767 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_286 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_886 (insn, operands);

        case 2:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_892 (insn, operands);

        case 3:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_904 (insn, operands);

        case 4:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_898 (insn, operands);

        case 5:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_910 (insn, operands);

        case 6:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_916 (insn, operands);

        default:
          return NULL;
        }

    case 75:
      x2 = XEXP (x1, 1);
      switch (pattern127 (x2))
        {
        case 0:
          if (!(
#line 2705 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2707 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_282 (insn, operands);

        case 1:
          if (!(
#line 2763 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND) && 
#line 2767 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_285 (insn, operands);

        case 2:
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          if (XWINT (x7, 0) != 2L)
            return NULL;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!(
#line 2836 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])) && 
#line 2839 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_289 (insn, operands);

        case 3:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_887 (insn, operands);

        case 4:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_893 (insn, operands);

        case 5:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_905 (insn, operands);

        case 6:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_899 (insn, operands);

        case 7:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_911 (insn, operands);

        case 8:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_917 (insn, operands);

        default:
          return NULL;
        }

    case 76:
      x2 = XEXP (x1, 1);
      switch (pattern128 (x2))
        {
        case 0:
          if (!(
#line 10796 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10799 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_874 (insn, operands);

        case 1:
          if (!(
#line 10796 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10799 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_877 (insn, operands);

        case 2:
          if (!(
#line 10796 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10799 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_880 (insn, operands);

        case 3:
          if (!(
#line 10796 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10799 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_883 (insn, operands);

        default:
          return NULL;
        }

    case 77:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_826 (insn, operands);

    case 78:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_838 (insn, operands);

    case 79:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_850 (insn, operands);

    case 80:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_862 (insn, operands);

    case 81:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_829 (insn, operands);

    case 82:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_841 (insn, operands);

    case 83:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_853 (insn, operands);

    case 84:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_865 (insn, operands);

    case 85:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_832 (insn, operands);

    case 86:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_844 (insn, operands);

    case 87:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_856 (insn, operands);

    case 88:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_868 (insn, operands);

    case 89:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_835 (insn, operands);

    case 90:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_847 (insn, operands);

    case 91:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_859 (insn, operands);

    case 92:
      if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_871 (insn, operands);

    case 93:
      if (!(
#line 10852 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10857 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_958 (insn, operands);

    case 94:
      if (!(
#line 10852 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10857 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_961 (insn, operands);

    case 95:
      if (!(
#line 10852 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10857 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_964 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_31 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (pattern300 (x1) != 0)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (REGNO (x4))
    {
    case 24:
      x5 = XEXP (x3, 1);
      if (REGNO (x5) != 22)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      if (REGNO (x8) != 24)
        return NULL;
      x9 = XEXP (x7, 1);
      if (REGNO (x9) != 22)
        return NULL;
      switch (pattern380 (x1))
        {
        case 0:
          if (!
#line 3927 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_346 (insn, operands);

        case 1:
          if (!
#line 4015 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_350 (insn, operands);

        default:
          return NULL;
        }

    case 22:
      if (pattern368 (x1, 
E_SImode, 
18, 
22) != 0
          || pattern363 (x1, 
E_HImode, 
26, 
E_SImode, 
22) != 0
          || pattern376 (x1, 
E_SImode, 
E_HImode, 
30) != 0
          || !
#line 4413 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_364 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_34 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG)
        return NULL;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case MEM:
          if (pattern185 (x3) != 0)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 21
              || GET_MODE (x7) != E_QImode)
            return NULL;
          switch (pattern382 (x1))
            {
            case 0:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_47 (insn, operands);

            case 1:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_48 (insn, operands);

            case 2:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_49 (insn, operands);

            case 3:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_50 (insn, operands);

            case 4:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_51 (insn, operands);

            case 5:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_52 (insn, operands);

            case 6:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_53 (insn, operands);

            case 7:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_54 (insn, operands);

            case 8:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_55 (insn, operands);

            case 9:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_56 (insn, operands);

            case 10:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_57 (insn, operands);

            case 11:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_58 (insn, operands);

            case 12:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_59 (insn, operands);

            case 13:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_60 (insn, operands);

            case 14:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_61 (insn, operands);

            default:
              return NULL;
            }

        case MULT:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          x8 = XEXP (x5, 0);
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) == REG)
                {
                  switch (pattern273 (x1))
                    {
                    case 0:
                      if ((
#line 2441 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 2443 "../../gcc/config/avr/avr.md"
( reload_completed)))
                        return gen_split_270 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL) && 
#line 678 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                        return gen_split_1976 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (GET_MODE (x8) != E_SImode)
                return NULL;
              switch (pattern277 (x1))
                {
                case 0:
                  if (!(
#line 3487 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3489 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_314 (insn, operands);

                case 1:
                  if (!(
#line 3487 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3489 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_315 (insn, operands);

                case 2:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_320 (insn, operands);

                case 3:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_328 (insn, operands);

                case 4:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_324 (insn, operands);

                case 5:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_332 (insn, operands);

                case 6:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_322 (insn, operands);

                case 7:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_330 (insn, operands);

                case 8:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_326 (insn, operands);

                case 9:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_334 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              if (GET_CODE (x8) == REG
                  && REGNO (x8) == 24)
                {
                  res = split_32 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                }
              operands[1] = x8;
              switch (pattern270 (x1))
                {
                case 0:
                  if (!(
#line 3407 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3409 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_312 (insn, operands);

                case 1:
                  if (!(
#line 4201 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 4203 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_356 (insn, operands);

                default:
                  return NULL;
                }

            case SIGN_EXTEND:
              if (REGNO (x7) != 26
                  || GET_MODE (x7) != E_HImode)
                return NULL;
              if (REGNO (x4) == 18)
                {
                  switch (pattern310 (x1))
                    {
                    case 0:
                      if ((
#line 3539 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3541 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_316 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 3539 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3541 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_317 (insn, operands);
                      break;

                    case 2:
                      if ((
#line 4182 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 4184 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_355 (insn, operands);
                      break;

                    case 3:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_319 (insn, operands);
                      break;

                    case 4:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_327 (insn, operands);
                      break;

                    case 5:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_323 (insn, operands);
                      break;

                    case 6:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_331 (insn, operands);
                      break;

                    case 7:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_321 (insn, operands);
                      break;

                    case 8:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_329 (insn, operands);
                      break;

                    case 9:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_325 (insn, operands);
                      break;

                    case 10:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_333 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != REG
                  || pattern311 (x1) != 0
                  || !(
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL) && 
#line 678 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1975 (insn, operands);

            case NOT:
              if (pattern250 (x1) != 0
                  || !(
#line 3598 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3600 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_318 (insn, operands);

            default:
              return NULL;
            }

        case UDIV:
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != REG)
            return NULL;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG)
            return NULL;
          switch (REGNO (x8))
            {
            case 24:
              switch (pattern281 (x1))
                {
                case 0:
                  if (!
#line 3971 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return NULL;
                  return gen_split_348 (insn, operands);

                case 1:
                  if (!
#line 610 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1854 (insn, operands);

                case 2:
                  if (!
#line 610 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1856 (insn, operands);

                default:
                  return NULL;
                }

            case 26:
              switch (pattern284 (x1))
                {
                case 0:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1846 (insn, operands);

                case 1:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1848 (insn, operands);

                case 2:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1850 (insn, operands);

                case 3:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1852 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case XOR:
          switch (pattern186 (x1))
            {
            case 0:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_387 (insn, operands);

            case 1:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_390 (insn, operands);

            case 2:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_393 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern186 (x1))
            {
            case 0:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_388 (insn, operands);

            case 1:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_391 (insn, operands);

            case 2:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_394 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern186 (x1))
            {
            case 0:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_389 (insn, operands);

            case 1:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_392 (insn, operands);

            case 2:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_395 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern188 (x1))
            {
            case 0:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_480 (insn, operands);

            case 1:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_483 (insn, operands);

            case 2:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3r (operands[2])))
                return NULL;
              return gen_split_486 (insn, operands);

            case 3:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_489 (insn, operands);

            case 4:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_492 (insn, operands);

            case 5:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_495 (insn, operands);

            case 6:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_498 (insn, operands);

            case 7:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_501 (insn, operands);

            case 8:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_504 (insn, operands);

            case 9:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_507 (insn, operands);

            case 10:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_510 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern188 (x1))
            {
            case 0:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_481 (insn, operands);

            case 1:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_484 (insn, operands);

            case 2:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3a (operands[2])))
                return NULL;
              return gen_split_487 (insn, operands);

            case 3:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_490 (insn, operands);

            case 4:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_493 (insn, operands);

            case 5:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_496 (insn, operands);

            case 6:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_499 (insn, operands);

            case 7:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_502 (insn, operands);

            case 8:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_505 (insn, operands);

            case 9:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_508 (insn, operands);

            case 10:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_511 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern188 (x1))
            {
            case 0:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_482 (insn, operands);

            case 1:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_485 (insn, operands);

            case 2:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3l (operands[2])))
                return NULL;
              return gen_split_488 (insn, operands);

            case 3:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_491 (insn, operands);

            case 4:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_494 (insn, operands);

            case 5:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_497 (insn, operands);

            case 6:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_500 (insn, operands);

            case 7:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_503 (insn, operands);

            case 8:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_506 (insn, operands);

            case 9:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_509 (insn, operands);

            case 10:
              if (!
#line 5659 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_512 (insn, operands);

            default:
              return NULL;
            }

        case TRUNCATE:
          if (pattern107 (x3, 
24, 
E_HImode) != 0)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || pattern316 (x1, 
E_QImode, 
26, 
22) != 0)
            return NULL;
          x8 = XEXP (x5, 0);
          switch (pattern360 (x8))
            {
            case 0:
              if (!
#line 9514 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_661 (insn, operands);

            case 1:
              if (!
#line 9586 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_663 (insn, operands);

            default:
              return NULL;
            }

        case DIV:
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != REG)
            return NULL;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern100 (x6, 
26, 
E_HImode) != 0)
            return NULL;
          switch (REGNO (x8))
            {
            case 26:
              if (REGNO (x10) != 22
                  || REGNO (x11) != 24)
                return NULL;
              switch (pattern282 (x1, 
E_QImode, 
21))
                {
                case 0:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1847 (insn, operands);

                case 1:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1849 (insn, operands);

                case 2:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1851 (insn, operands);

                case 3:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1853 (insn, operands);

                default:
                  return NULL;
                }

            case 24:
              if (REGNO (x10) != 18
                  || REGNO (x11) != 22)
                return NULL;
              switch (pattern279 (x1))
                {
                case 0:
                  if (!
#line 610 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1855 (insn, operands);

                case 1:
                  if (!
#line 610 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1857 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 10)
        return NULL;
      x12 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x12) != CONST_INT)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return NULL;
      x13 = XEXP (x6, 1);
      if (pattern103 (x13) != 0)
        return NULL;
      x14 = XVECEXP (x3, 0, 0);
      operands[0] = x14;
      switch (pattern251 (x1))
        {
        case 0:
          if (!
#line 8786 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_636 (insn, operands);

        case 1:
          if (!
#line 8818 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_637 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
