/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return pattern6 (); /* [-1, 3] */
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonmemory_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return pattern9 (); /* [-1, 3] */
}

int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!combine_pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!combine_pseudo_register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  switch (REGNO (x3))
    {
    case 25:
      if (REGNO (x4) != 22
          || REGNO (x5) != 24)
        return -1;
      switch (GET_MODE (x5))
        {
        case E_QQmode:
          if (GET_MODE (x2) != E_QQmode
              || GET_MODE (x3) != E_QQmode
              || GET_MODE (x4) != E_QQmode)
            return -1;
          return 0;

        case E_UQQmode:
          if (GET_MODE (x2) != E_UQQmode
              || GET_MODE (x3) != E_UQQmode
              || GET_MODE (x4) != E_UQQmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 26:
      res = pattern24 (x1, 
22);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    case 24:
      if (REGNO (x4) != 18)
        return -1;
      res = pattern25 (x1, 
22);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || pattern34 (x1, 
E_HImode, 
24) != 0)
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case AND:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      res = pattern38 (x3);
      if (res >= 0)
        return res + 1; /* [1, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  return pattern46 (x1); /* [-1, 5] */
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      res = pattern18 (x2);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      res = pattern19 (x2);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 6;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 7;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_UQQmode:
      return pattern60 (x1, 
E_UQQmode); /* [-1, 0] */

    case E_UHQmode:
      if (pattern60 (x1, 
E_UHQmode) != 0)
        return -1;
      return 1;

    case E_UHAmode:
      if (pattern60 (x1, 
E_UHAmode) != 0)
        return -1;
      return 2;

    case E_USAmode:
      if (pattern60 (x1, 
E_USAmode) != 0)
        return -1;
      return 3;

    case E_USQmode:
      if (pattern60 (x1, 
E_USQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DImode
          || !const_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x2) != E_DQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DQmode
          || !const_operand (operands[0], E_DQmode))
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x2) != E_UDQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDQmode
          || !const_operand (operands[0], E_UDQmode))
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x2) != E_DAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DAmode
          || !const_operand (operands[0], E_DAmode))
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x2) != E_UDAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDAmode
          || !const_operand (operands[0], E_UDAmode))
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x2) != E_TAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_TAmode
          || !const_operand (operands[0], E_TAmode))
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x2) != E_UTAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UTAmode
          || !const_operand (operands[0], E_UTAmode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      return 0;

    case ZERO_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != CONST_INT)
            return -1;
          return 1;

        case AND:
          res = pattern2 (x1);
          if (res >= 0)
            return res + 2; /* [2, 7] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          x6 = XEXP (x1, 1);
          res = pattern81 (x6);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case AND:
          res = pattern2 (x1);
          if (res >= 0)
            return res + 10; /* [10, 15] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern94 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!reg_or_low_io_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x2, 2);
  operands[2] = x6;
  if (!const_0_to_7_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern100 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != i2)
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x6) != E_QQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 0;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 1;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 2;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 3;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 4;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 5;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 6;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 7;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 8;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 9;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 10;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 11;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 12;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 13;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 14;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 15;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 16;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 17;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x6) != E_UQQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 19;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 20;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 21;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 22;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 23;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 24;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 25;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 26;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 27;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 28;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 29;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 30;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 31;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 32;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 33;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 34;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 35;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 36;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 37;

        default:
          return -1;
        }

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x6) != E_HQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 38;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 39;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 40;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 41;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 42;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 43;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 44;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 45;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 46;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 47;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 48;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 49;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 50;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 51;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 52;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 53;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 54;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 55;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x6) != E_UHQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 57;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 58;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 59;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 60;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 61;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 62;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 63;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 64;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 65;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 66;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 67;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 68;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 69;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 70;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 71;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 72;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 73;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 74;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 75;

        default:
          return -1;
        }

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x6) != E_HAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 76;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 77;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 78;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 79;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 80;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 81;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 82;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 83;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 84;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 85;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 86;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 87;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 88;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 89;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 90;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 91;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 92;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 93;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x6) != E_UHAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 95;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 96;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 97;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 98;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 99;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 100;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 101;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 102;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 103;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 104;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 105;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 106;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 107;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 108;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 109;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 110;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 111;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 112;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x6) != E_SQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 114;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 115;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 116;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 117;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 118;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 119;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 120;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 121;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 122;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 123;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 124;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 125;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 126;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 127;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 128;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 129;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 130;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 131;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 132;

        default:
          return -1;
        }

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x6) != E_USQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 133;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 134;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 135;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 136;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 137;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 138;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 139;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 140;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 141;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 142;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 143;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 144;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 145;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 146;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 147;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 148;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 149;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 150;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 151;

        default:
          return -1;
        }

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x6) != E_SAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 152;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 153;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 154;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 155;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 156;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 157;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 158;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 159;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 160;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 161;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 162;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 163;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 164;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 165;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 166;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 167;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 168;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 169;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 170;

        default:
          return -1;
        }

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x6) != E_USAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 171;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 172;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 173;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 174;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 175;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 176;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 177;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 178;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 179;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 180;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 181;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 182;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 183;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 184;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 185;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 186;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 187;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 188;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 189;

        default:
          return -1;
        }

    case E_DQmode:
      if (!register_operand (operands[0], E_DQmode)
          || GET_MODE (x6) != E_DQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 190;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 191;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 192;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 193;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 194;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 195;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 196;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 197;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 198;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 199;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 200;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 201;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 202;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 203;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 204;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 205;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 206;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 207;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 208;

        default:
          return -1;
        }

    case E_UDQmode:
      if (!register_operand (operands[0], E_UDQmode)
          || GET_MODE (x6) != E_UDQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 209;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 210;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 211;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 212;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 213;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 214;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 215;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 216;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 217;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 218;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 219;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 220;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 221;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 222;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 223;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 224;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 225;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 226;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 227;

        default:
          return -1;
        }

    case E_DAmode:
      if (!register_operand (operands[0], E_DAmode)
          || GET_MODE (x6) != E_DAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 228;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 229;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 230;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 231;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 232;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 233;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 234;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 235;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 236;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 237;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 238;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 239;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 240;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 241;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 242;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 243;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 244;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 245;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 246;

        default:
          return -1;
        }

    case E_UDAmode:
      if (!register_operand (operands[0], E_UDAmode)
          || GET_MODE (x6) != E_UDAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 247;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 248;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 249;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 250;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 251;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 252;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 253;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 254;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 255;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 256;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 257;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 258;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 259;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 260;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 261;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 262;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 263;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 264;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 265;

        default:
          return -1;
        }

    case E_TAmode:
      if (!register_operand (operands[0], E_TAmode)
          || GET_MODE (x6) != E_TAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 266;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 267;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 268;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 269;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 270;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 271;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 272;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 273;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 274;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 275;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 276;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 277;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 278;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 279;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 280;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 281;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 282;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 283;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 284;

        default:
          return -1;
        }

    case E_UTAmode:
      if (!register_operand (operands[0], E_UTAmode)
          || GET_MODE (x6) != E_UTAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 285;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 286;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 287;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 288;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 289;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 290;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 291;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 292;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 293;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 294;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 295;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 296;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 297;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 298;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 299;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 300;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 301;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 302;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 303;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x6) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 304;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 305;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 306;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 307;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 308;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 309;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 310;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 311;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 312;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 313;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 314;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 315;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 316;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 317;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 318;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 319;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 320;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 321;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 322;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x6) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 323;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 324;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 325;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 326;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 327;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 328;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 329;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 330;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 331;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 332;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 333;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 334;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 335;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 336;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 337;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 338;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 339;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 340;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 341;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 342;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 343;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 344;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 345;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 346;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 347;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 348;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 349;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 350;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 351;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 352;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 353;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 354;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 355;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 356;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 357;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 358;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 359;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 360;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 361;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 362;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 363;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 364;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 365;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 366;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 367;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 368;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 369;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 370;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 371;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 372;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 373;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 374;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 375;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 376;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 377;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 378;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 379;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      switch (pattern54 (x1, pnum_clobbers))
        {
        case 0:
          return 743; /* *lshrqi3_split */

        case 1:
          return 744; /* *lshrqq3_split */

        case 2:
          return 745; /* *lshruqq3_split */

        case 3:
          if (nop_general_operand (operands[2], E_QImode))
            return 749; /* lshrhi3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6187 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 771; /* *lshrhi3_const */
            }
          break;

        case 4:
          if (nop_general_operand (operands[2], E_QImode))
            return 750; /* lshrhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6187 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 772; /* *lshrhq3_const */
            }
          break;

        case 5:
          if (nop_general_operand (operands[2], E_QImode))
            return 751; /* lshruhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6187 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 773; /* *lshruhq3_const */
            }
          break;

        case 6:
          if (nop_general_operand (operands[2], E_QImode))
            return 752; /* lshrha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6187 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 774; /* *lshrha3_const */
            }
          break;

        case 7:
          if (nop_general_operand (operands[2], E_QImode))
            return 753; /* lshruha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6187 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 775; /* *lshruha3_const */
            }
          break;

        case 8:
          *pnum_clobbers = 1;
          return 759; /* lshrpsi3 */

        case 9:
          return 761; /* lshrsi3 */

        case 10:
          return 762; /* lshrsq3 */

        case 11:
          return 763; /* lshrusq3 */

        case 12:
          return 764; /* lshrsa3 */

        case 13:
          return 765; /* lshrusa3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      if (pattern55 (x1) == 0)
        return 1082; /* *insv.shiftrt */
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) == E_QImode)
    {
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 7])
        {
          operands[0] = x2;
          if (register_operand (operands[0], E_QImode))
            {
              x5 = XEXP (x3, 0);
              operands[1] = x5;
              if (reg_or_low_io_operand (operands[1], E_QImode)
                  && 
#line 10599 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1181; /* *extzv.io.lsr7 */
            }
        }
    }
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 18)
    return -1;
  switch (pattern87 (x1))
    {
    case 0:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3306; /* lshrdi3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3334; /* *lshrdi3_insn */

    case 1:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3310; /* lshrdq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3338; /* *lshrdq3_insn */

    case 2:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3314; /* lshrudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3342; /* *lshrudq3_insn */

    case 3:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3318; /* lshrda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3346; /* *lshrda3_insn */

    case 4:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3322; /* lshruda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3350; /* *lshruda3_insn */

    case 5:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3326; /* lshrta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3354; /* *lshrta3_insn */

    case 6:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3330; /* lshruta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3358; /* *lshruta3_insn */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case LSHIFTRT:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MULT)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x6) == E_HImode
              && pattern202 (x1, 
SIGN_EXTEND) == 0)
            {
              if (
#line 2269 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 304; /* smulqi3_highpart */
              if (pnum_clobbers != NULL
                  && 
#line 2286 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 306; /* *smulqi3_highpart */
                }
            }
          if (pnum_clobbers == NULL
              || pattern203 (x1, 
SIGN_EXTEND) != 0)
            return -1;
          if (
#line 3804 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 572; /* *smulhi3_highpart_call_split */
            }
          if (!
#line 3821 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 574; /* *smulhi3_highpart_call */

        case ZERO_EXTEND:
          if (GET_MODE (x6) == E_HImode
              && pattern202 (x1, 
ZERO_EXTEND) == 0)
            {
              if (
#line 2269 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 305; /* umulqi3_highpart */
              if (pnum_clobbers != NULL
                  && 
#line 2286 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 307; /* *umulqi3_highpart */
                }
            }
          if (pnum_clobbers == NULL
              || pattern203 (x1, 
ZERO_EXTEND) != 0)
            return -1;
          if (
#line 3804 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 573; /* *umulhi3_highpart_call_split */
            }
          if (!
#line 3821 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 575; /* *umulhi3_highpart_call */

        default:
          return -1;
        }

    case PARITY:
      if (GET_MODE (x3) != E_SImode
          || pattern35 (x1, 
E_SImode, 
22) != 0)
        return -1;
      return 1029; /* *paritysihi2.libgcc_split */

    case POPCOUNT:
      if (GET_MODE (x3) != E_SImode
          || pattern35 (x1, 
E_SImode, 
22) != 0)
        return -1;
      return 1034; /* *popcountsi2.libgcc_split */

    case CLZ:
      if (pattern36 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 1041; /* *clzsihi2.libgcc_split */

    case CTZ:
      if (pattern36 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 2;
      return 1045; /* *ctzsihi2.libgcc_split */

    case FFS:
      if (pattern36 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 2;
      return 1049; /* *ffssihi2.libgcc_split */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == REG)
    {
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers != NULL)
    {
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (register_operand (operands[2], E_QImode))
        {
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (register_operand (operands[0], E_QImode)
                  && const_operand (operands[1], E_QImode)
                  && 
#line 885 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 119; /* *reload_inqi */
                }
              break;

            case E_QQmode:
              if (register_operand (operands[0], E_QQmode)
                  && const_operand (operands[1], E_QQmode)
                  && 
#line 885 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 120; /* *reload_inqq */
                }
              break;

            case E_UQQmode:
              if (register_operand (operands[0], E_UQQmode)
                  && const_operand (operands[1], E_UQQmode)
                  && 
#line 885 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 121; /* *reload_inuqq */
                }
              break;

            case E_PSImode:
              if (register_operand (operands[0], E_PSImode)
                  && immediate_operand (operands[1], E_PSImode)
                  && 
#line 1125 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 138; /* *reload_inpsi */
                }
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && immediate_operand (operands[1], E_SImode)
                  && 
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 141; /* *reload_insi */
                }
              break;

            case E_SQmode:
              if (register_operand (operands[0], E_SQmode)
                  && immediate_operand (operands[1], E_SQmode)
                  && 
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 142; /* *reload_insi */
                }
              break;

            case E_USQmode:
              if (register_operand (operands[0], E_USQmode)
                  && immediate_operand (operands[1], E_USQmode)
                  && 
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 143; /* *reload_insi */
                }
              break;

            case E_SAmode:
              if (register_operand (operands[0], E_SAmode)
                  && immediate_operand (operands[1], E_SAmode)
                  && 
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 144; /* *reload_insi */
                }
              break;

            case E_USAmode:
              if (register_operand (operands[0], E_USAmode)
                  && immediate_operand (operands[1], E_USAmode)
                  && 
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 145; /* *reload_insi */
                }
              break;

            case E_SFmode:
              if (register_operand (operands[0], E_SFmode)
                  && const_double_operand (operands[1], E_SFmode)
                  && 
#line 1283 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 159; /* *reload_insf */
                }
              break;

            default:
              break;
            }
        }
    }
  operands[0] = x3;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (pattern231 (x6))
    {
    case 0:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 35; /* fxmovqi_A */

    case 1:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 36; /* fxmovqq_A */

    case 2:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 37; /* fxmovuqq_A */

    case 3:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 38; /* fxmovhi_A */

    case 4:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 39; /* fxmovhq_A */

    case 5:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 40; /* fxmovuhq_A */

    case 6:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 41; /* fxmovha_A */

    case 7:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 42; /* fxmovuha_A */

    case 8:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 43; /* fxmovsi_A */

    case 9:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 44; /* fxmovsq_A */

    case 10:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 45; /* fxmovusq_A */

    case 11:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 46; /* fxmovsa_A */

    case 12:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 47; /* fxmovusa_A */

    case 13:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 48; /* fxmovsf_A */

    case 14:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 49; /* fxmovpsi_A */

    case 15:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || !nox_general_operand (operands[1], E_QImode)
              || !
#line 866 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))
   && reload_completed))
            return -1;
          return 116; /* movqi_insn */

        case E_QQmode:
          if (!nonimmediate_operand (operands[0], E_QQmode)
              || !nox_general_operand (operands[1], E_QQmode)
              || !
#line 866 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode))
   && reload_completed))
            return -1;
          return 117; /* movqq_insn */

        case E_UQQmode:
          if (!nonimmediate_operand (operands[0], E_UQQmode)
              || !nox_general_operand (operands[1], E_UQQmode)
              || !
#line 866 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode))
   && reload_completed))
            return -1;
          return 118; /* movuqq_insn */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !nox_general_operand (operands[1], E_HImode)
              || !
#line 975 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))
   && reload_completed))
            return -1;
          return 133; /* *movhi */

        case E_HQmode:
          if (!nonimmediate_operand (operands[0], E_HQmode)
              || !nox_general_operand (operands[1], E_HQmode)
              || !
#line 975 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], HQmode)
    || reg_or_0_operand (operands[1], HQmode))
   && reload_completed))
            return -1;
          return 134; /* *movhq */

        case E_UHQmode:
          if (!nonimmediate_operand (operands[0], E_UHQmode)
              || !nox_general_operand (operands[1], E_UHQmode)
              || !
#line 975 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], UHQmode)
    || reg_or_0_operand (operands[1], UHQmode))
   && reload_completed))
            return -1;
          return 135; /* *movuhq */

        case E_HAmode:
          if (!nonimmediate_operand (operands[0], E_HAmode)
              || !nox_general_operand (operands[1], E_HAmode)
              || !
#line 975 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], HAmode)
    || reg_or_0_operand (operands[1], HAmode))
   && reload_completed))
            return -1;
          return 136; /* *movha */

        case E_UHAmode:
          if (!nonimmediate_operand (operands[0], E_UHAmode)
              || !nox_general_operand (operands[1], E_UHAmode)
              || !
#line 975 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], UHAmode)
    || reg_or_0_operand (operands[1], UHAmode))
   && reload_completed))
            return -1;
          return 137; /* *movuha */

        case E_PSImode:
          if (!nonimmediate_operand (operands[0], E_PSImode)
              || !nox_general_operand (operands[1], E_PSImode)
              || !
#line 1148 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], PSImode)
    || register_operand (operands[1], PSImode)
    || const0_rtx == operands[1])
   && reload_completed))
            return -1;
          return 140; /* *movpsi */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !nox_general_operand (operands[1], E_SImode)
              || !
#line 1208 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && reload_completed))
            return -1;
          return 151; /* *movsi */

        case E_SQmode:
          if (!nonimmediate_operand (operands[0], E_SQmode)
              || !nox_general_operand (operands[1], E_SQmode)
              || !
#line 1208 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SQmode)
    || reg_or_0_operand (operands[1], SQmode))
   && reload_completed))
            return -1;
          return 152; /* *movsq */

        case E_USQmode:
          if (!nonimmediate_operand (operands[0], E_USQmode)
              || !nox_general_operand (operands[1], E_USQmode)
              || !
#line 1208 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], USQmode)
    || reg_or_0_operand (operands[1], USQmode))
   && reload_completed))
            return -1;
          return 153; /* *movusq */

        case E_SAmode:
          if (!nonimmediate_operand (operands[0], E_SAmode)
              || !nox_general_operand (operands[1], E_SAmode)
              || !
#line 1208 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SAmode)
    || reg_or_0_operand (operands[1], SAmode))
   && reload_completed))
            return -1;
          return 154; /* *movsa */

        case E_USAmode:
          if (!nonimmediate_operand (operands[0], E_USAmode)
              || !nox_general_operand (operands[1], E_USAmode)
              || !
#line 1208 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], USAmode)
    || reg_or_0_operand (operands[1], USAmode))
   && reload_completed))
            return -1;
          return 155; /* *movusa */

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || !nox_general_operand (operands[1], E_SFmode)
              || !
#line 1256 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && reload_completed))
            return -1;
          return 158; /* *movsf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern100 (x2, 
36, 
E_CCmode) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x4) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 6405 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 799; /* *one_cmplqi2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 6423 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 801; /* *one_cmplhi2 */

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x4) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || !
#line 6442 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 803; /* *one_cmplpsi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 6460 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 805; /* *one_cmplsi2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_QImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != ZERO_EXTRACT
          || GET_MODE (x6) != E_QImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x10 = XEXP (x6, 2);
      operands[1] = x10;
      if (!const_0_to_7_operand (operands[1], E_QImode)
          || GET_MODE (x4) != E_QImode)
        return -1;
      x11 = XEXP (x5, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x12 = XEXP (x5, 2);
      operands[3] = x12;
      if (!const_0_to_7_operand (operands[3], E_QImode)
          || !
#line 10094 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1084; /* insv_notbit */

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case LSHIFTRT:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != MULT)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x9) == E_HImode
              && pattern292 (x1, 
SIGN_EXTEND) == 0
              && 
#line 2286 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 306; /* *smulqi3_highpart */
          if (GET_MODE (x9) != E_SImode
              || pattern293 (x1, 
SIGN_EXTEND) != 0
              || !
#line 3804 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 572; /* *smulhi3_highpart_call_split */

        case ZERO_EXTEND:
          if (GET_MODE (x9) == E_HImode
              && pattern292 (x1, 
ZERO_EXTEND) == 0
              && 
#line 2286 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 307; /* *umulqi3_highpart */
          if (GET_MODE (x9) != E_SImode
              || pattern293 (x1, 
ZERO_EXTEND) != 0
              || !
#line 3804 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 573; /* *umulhi3_highpart_call_split */

        default:
          return -1;
        }

    case PARITY:
      if (pattern208 (x1, 
E_CCmode, 
36) != 0
          || !
#line 9282 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1030; /* *paritysihi2.libgcc */

    case POPCOUNT:
      if (pattern208 (x1, 
E_CCmode, 
36) != 0
          || !
#line 9358 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1035; /* *popcountsi2.libgcc */

    case CLZ:
      if (pattern208 (x1, 
E_QImode, 
26) != 0)
        return -1;
      return 1041; /* *clzsihi2.libgcc_split */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PARITY
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  if (REGNO (x6) == 24
      && GET_MODE (x6) == E_HImode)
    {
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (register_operand (operands[0], E_HImode))
        {
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (register_operand (operands[1], E_QImode)
              && 
#line 9194 "../../gcc/config/avr/avr.md"
(!reload_completed))
            return 1023; /* *parityqihi2.1 */
        }
    }
  if (REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x8 = XEXP (x4, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 24
      || GET_MODE (x8) != E_QImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 24
      || GET_MODE (x7) != E_HImode
      || !
#line 9264 "../../gcc/config/avr/avr.md"
(reload_completed))
    return -1;
  return 1028; /* *parityqihi2.libgcc */
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern248 (x1, 
MOD))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != MOD)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 22)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern380 (x1))
        {
        case 0:
          return 585; /* *divmodqi4_call_split */

        case 1:
          return 591; /* *divmodhi4_call_split */

        default:
          return -1;
        }

    case 1:
      switch (pattern331 (x1))
        {
        case 0:
          if (!
#line 625 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3123; /* *divsa3.call */

        case 1:
          if (!
#line 625 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3125; /* *divusa3.call */

        default:
          return -1;
        }

    case 2:
      return 613; /* *divmodsi4_call_split */

    case 3:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3111; /* *divhq3.call */

    case 4:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3113; /* *divuhq3.call */

    case 5:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3115; /* *divha3.call */

    case 6:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3117; /* *divuha3.call */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 0);
  switch (REGNO (x6))
    {
    case 24:
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      if (REGNO (x8) != 22)
        return -1;
      switch (REGNO (x4))
        {
        case 22:
          if (REGNO (x5) != 24)
            return -1;
          x9 = XVECEXP (x1, 0, 2);
          x10 = XEXP (x9, 0);
          switch (REGNO (x10))
            {
            case 36:
              if (pattern362 (x1, 
E_QImode, 
E_CCmode) != 0
                  || !
#line 2256 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
                return -1;
              return 303; /* *mulqi3_call */

            case 21:
              if (pattern362 (x1, 
E_HImode, 
E_QImode) != 0
                  || !
#line 3319 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                return -1;
              return 539; /* *mulhi3_call_split */

            default:
              return -1;
            }

        case 25:
          if (pattern344 (x1) != 0
              || !
#line 377 "../../gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL))
            return -1;
          return 3080; /* *mulqq3.call_split */

        default:
          return -1;
        }

    case 22:
      if (GET_MODE (x6) != E_SImode
          || REGNO (x4) != 18
          || GET_MODE (x4) != E_SImode
          || REGNO (x5) != 22
          || GET_MODE (x5) != E_SImode
          || pattern363 (x1, 
E_CCmode, 
36, 
E_HImode, 
26) != 0
          || GET_MODE (x3) != E_SImode
          || !
#line 3754 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 566; /* *mulsi3_call */

    case 18:
      switch (pattern312 (x1, 
E_CCmode, 
36, 
22, 
26))
        {
        case 0:
          if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3086; /* *mulhq3.call */

        case 1:
          if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3087; /* *muluhq3.call */

        case 2:
          if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3088; /* *mulha3.call */

        case 3:
          if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3089; /* *muluha3.call */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_83 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (pnum_clobbers == NULL
              || pattern175 (x1) != 0)
            return -1;
          x4 = XEXP (x3, 1);
          x5 = XEXP (x4, 1);
          operands[0] = x5;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          x7 = XEXP (x6, 1);
          x8 = XEXP (x7, 1);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          *pnum_clobbers = 2;
          return 997; /* epilogue_restores */

        case 2:
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != UNSPEC_VOLATILE
              || XVECLEN (x4, 0) != 1)
            return -1;
          x9 = XVECEXP (x2, 0, 0);
          operands[0] = x9;
          switch (XINT (x2, 1))
            {
            case 3:
              if (pnum_clobbers == NULL
                  || pattern285 (x1) != 0
                  || !
#line 8712 "../../gcc/config/avr/avr.md"
(avropt_gasisr_prologues))
                return -1;
              *pnum_clobbers = 1;
              return 998; /* *gasisr */

            case 10:
              switch (pattern252 (x1))
                {
                case 0:
                  return 1003; /* delay_cycles_1 */

                case 1:
                  return 1005; /* delay_cycles_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x4))
    {
    case SET:
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L
              || pattern174 (x1) != 0
              || REGNO (x6) != 36
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (pattern294 (x1))
            {
            case 0:
              if (!
#line 1480 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 169; /* *clrmemqi */

            case 1:
              if (!
#line 1514 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 171; /* *clrmemhi */

            default:
              return -1;
            }

        case DIV:
          if (pattern230 (x1, 
MOD) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          switch (pattern349 (x1))
            {
            case 0:
              return 584; /* divmodqi4 */

            case 1:
              return 590; /* divmodhi4 */

            case 2:
              return 612; /* divmodsi4 */

            default:
              break;
            }
          x9 = XEXP (x2, 0);
          if (REGNO (x9) != 26
              || pattern350 (x1) != 0
              || !
#line 4328 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 608; /* *divmodpsi4_call */

        case UDIV:
          if (pattern230 (x1, 
UMOD) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          switch (pattern349 (x1))
            {
            case 0:
              return 587; /* udivmodqi4 */

            case 1:
              return 593; /* udivmodhi4 */

            case 2:
              return 615; /* udivmodsi4 */

            default:
              break;
            }
          x9 = XEXP (x2, 0);
          if (REGNO (x9) != 26
              || pattern350 (x1) != 0
              || !
#line 4377 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 611; /* *udivmodpsi4_call */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (pattern148 (x1) != 0)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          x11 = XEXP (x10, 0);
          if (GET_MODE (x11) != E_HImode)
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != USE
              || pattern375 (x1, 
E_CCmode, 
36) != 0)
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          operands[0] = x12;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x13 = XEXP (x10, 1);
          x14 = XEXP (x13, 1);
          operands[1] = x14;
          if (!immediate_operand (operands[1], E_HImode))
            return -1;
          return 996; /* call_prologue_saves */

        case 2:
          if (XINT (x4, 1) != 10)
            return -1;
          x15 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x12) != SET)
            return -1;
          x16 = XEXP (x12, 1);
          if (GET_CODE (x16) != UNSPEC_VOLATILE
              || XVECLEN (x16, 0) != 1
              || XINT (x16, 1) != 6
              || GET_MODE (x16) != E_BLKmode)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != CLOBBER
              || pattern253 (x1) != 0)
            return -1;
          switch (XWINT (x15, 0))
            {
            case 3L:
              x6 = XEXP (x3, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 36
                  || GET_MODE (x6) != E_CCmode
                  || !
#line 8876 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1008; /* *delay_cycles_3 */

            case 4L:
              x6 = XEXP (x3, 0);
              operands[5] = x6;
              if (!scratch_operand (operands[5], E_QImode))
                return -1;
              return 1009; /* delay_cycles_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern129 (x2))
        {
        case 0:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_135 (insn, operands);

        case 1:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_137 (insn, operands);

        case 2:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_141 (insn, operands);

        case 3:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_139 (insn, operands);

        case 4:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_143 (insn, operands);

        case 5:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_145 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern129 (x2))
        {
        case 0:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_136 (insn, operands);

        case 1:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_138 (insn, operands);

        case 2:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_142 (insn, operands);

        case 3:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_140 (insn, operands);

        case 4:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_144 (insn, operands);

        case 5:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_146 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_PSImode:
          if (pattern194 (x2, 
E_PSImode) != 0
              || !
#line 2081 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_148 (insn, operands);

        case E_QImode:
          if (pattern217 (x2, 
E_QImode) != 0
              || !
#line 2108 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_149 (insn, operands);

        case E_QQmode:
          if (pattern217 (x2, 
E_QQmode) != 0
              || !
#line 2108 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_150 (insn, operands);

        case E_UQQmode:
          if (pattern217 (x2, 
E_UQQmode) != 0
              || !
#line 2108 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_151 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern130 (x2))
        {
        case 0:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_166 (insn, operands);

        case 1:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_168 (insn, operands);

        case 2:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_170 (insn, operands);

        case 3:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_172 (insn, operands);

        case 4:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_194 (insn, operands);

        case 5:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_196 (insn, operands);

        case 6:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_200 (insn, operands);

        case 7:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_198 (insn, operands);

        case 8:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_202 (insn, operands);

        case 9:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_204 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern130 (x2))
        {
        case 0:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_167 (insn, operands);

        case 1:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_169 (insn, operands);

        case 2:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_171 (insn, operands);

        case 3:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_173 (insn, operands);

        case 4:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_195 (insn, operands);

        case 5:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_197 (insn, operands);

        case 6:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_201 (insn, operands);

        case 7:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_199 (insn, operands);

        case 8:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_203 (insn, operands);

        case 9:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_205 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      switch (pattern132 (x2))
        {
        case 0:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_238 (insn, operands);

        case 1:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_246 (insn, operands);

        case 2:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_254 (insn, operands);

        case 3:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_262 (insn, operands);

        case 4:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_240 (insn, operands);

        case 5:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_248 (insn, operands);

        case 6:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_256 (insn, operands);

        case 7:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_264 (insn, operands);

        case 8:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_242 (insn, operands);

        case 9:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_250 (insn, operands);

        case 10:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_258 (insn, operands);

        case 11:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_266 (insn, operands);

        case 12:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_244 (insn, operands);

        case 13:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_252 (insn, operands);

        case 14:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_260 (insn, operands);

        case 15:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_268 (insn, operands);

        default:
          return NULL;
        }

    case LT:
      switch (pattern132 (x2))
        {
        case 0:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_239 (insn, operands);

        case 1:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_247 (insn, operands);

        case 2:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_255 (insn, operands);

        case 3:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_263 (insn, operands);

        case 4:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_241 (insn, operands);

        case 5:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_249 (insn, operands);

        case 6:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_257 (insn, operands);

        case 7:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_265 (insn, operands);

        case 8:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_243 (insn, operands);

        case 9:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_251 (insn, operands);

        case 10:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_259 (insn, operands);

        case 11:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_267 (insn, operands);

        case 12:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_245 (insn, operands);

        case 13:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_253 (insn, operands);

        case 14:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_261 (insn, operands);

        case 15:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_269 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (pattern192 (x2) != 0
              || !register_operand (operands[2], E_QImode)
              || !(
#line 2622 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2624 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_278 (insn, operands);

        case SIGN_EXTEND:
          if (pattern214 (x2) != 0)
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2734 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2736 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_283 (insn, operands);

            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2798 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND) && 
#line 2802 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_288 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (pattern214 (x2) != 0)
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2734 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2736 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_284 (insn, operands);

            case SIGN_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2798 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND) && 
#line 2802 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_287 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      if (!register_operand (x3, E_QImode)
          || GET_MODE (x2) != E_QImode)
        return NULL;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[2] = x4;
          if (!register_operand (operands[2], E_QImode))
            return NULL;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          operands[1] = x3;
          if (!
#line 4760 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_375 (insn, operands);

        case CONST_INT:
          if (XWINT (x4, 0) != 1L)
            return NULL;
          x5 = XEXP (x1, 0);
          if (GET_CODE (x5) != ZERO_EXTRACT
              || GET_MODE (x5) != E_QImode)
            return NULL;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          x8 = XEXP (x5, 2);
          operands[1] = x8;
          if (!const_0_to_7_operand (operands[1], E_QImode))
            return NULL;
          operands[2] = x3;
          if (!
#line 10125 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_674 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern80 (x2))
        {
        case 0:
          if (!(
#line 10191 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10193 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_679 (insn, operands);

        case 1:
          if (!(
#line 10191 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10193 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_683 (insn, operands);

        case 2:
          if (!(
#line 10191 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10193 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_687 (insn, operands);

        case 3:
          if (!
#line 11031 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1030 (insn, operands);

        case 4:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_703 (insn, operands);

        case 5:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_707 (insn, operands);

        case 6:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_715 (insn, operands);

        case 7:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_711 (insn, operands);

        case 8:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_719 (insn, operands);

        case 9:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_723 (insn, operands);

        case 10:
          if (!
#line 11082 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1036 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern48 (x1))
        {
        case 0:
          if (!(
#line 10191 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10193 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_681 (insn, operands);

        case 1:
          if (!(
#line 10191 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10193 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_685 (insn, operands);

        case 2:
          if (!(
#line 10191 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10193 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_689 (insn, operands);

        case 3:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_705 (insn, operands);

        case 4:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_709 (insn, operands);

        case 5:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_717 (insn, operands);

        case 6:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_713 (insn, operands);

        case 7:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_721 (insn, operands);

        case 8:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_725 (insn, operands);

        case 9:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_927 (insn, operands);

        case 10:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_933 (insn, operands);

        case 11:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_945 (insn, operands);

        case 12:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_939 (insn, operands);

        case 13:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_951 (insn, operands);

        case 14:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_957 (insn, operands);

        case 15:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_926 (insn, operands);

        case 16:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_932 (insn, operands);

        case 17:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_944 (insn, operands);

        case 18:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_938 (insn, operands);

        case 19:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_950 (insn, operands);

        case 20:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_956 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      switch (pattern3 (x2))
        {
        case 0:
          if (!(
#line 10214 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 10216 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_691 (insn, operands);

        case 1:
          if (!(
#line 10214 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 10216 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_693 (insn, operands);

        case 2:
          if (!(
#line 10214 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 10216 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_697 (insn, operands);

        case 3:
          if (!(
#line 10214 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 10216 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_695 (insn, operands);

        case 4:
          if (!(
#line 10214 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 10216 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_699 (insn, operands);

        case 5:
          if (!(
#line 10214 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 10216 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_701 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x9 = XEXP (x3, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_828 (insn, operands);

            case 1:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_840 (insn, operands);

            case 2:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_852 (insn, operands);

            case 3:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_864 (insn, operands);

            case 4:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_831 (insn, operands);

            case 5:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_843 (insn, operands);

            case 6:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_855 (insn, operands);

            case 7:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_867 (insn, operands);

            case 8:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_834 (insn, operands);

            case 9:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_846 (insn, operands);

            case 10:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_858 (insn, operands);

            case 11:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_870 (insn, operands);

            case 12:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_837 (insn, operands);

            case 13:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_849 (insn, operands);

            case 14:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_861 (insn, operands);

            case 15:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_873 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!(
#line 10852 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10857 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_960 (insn, operands);

            case 1:
              if (!(
#line 10852 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10857 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_963 (insn, operands);

            case 2:
              if (!(
#line 10852 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10857 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_966 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern86 (x2))
        {
        case 0:
          if (!(
#line 10796 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10799 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_876 (insn, operands);

        case 1:
          if (!(
#line 10796 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10799 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_879 (insn, operands);

        case 2:
          if (!(
#line 10796 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10799 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_882 (insn, operands);

        case 3:
          if (!(
#line 10796 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10799 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_885 (insn, operands);

        case 4:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_890 (insn, operands);

        case 5:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_896 (insn, operands);

        case 6:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_908 (insn, operands);

        case 7:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_902 (insn, operands);

        case 8:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_914 (insn, operands);

        case 9:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_920 (insn, operands);

        case 10:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_891 (insn, operands);

        case 11:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_897 (insn, operands);

        case 12:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_909 (insn, operands);

        case 13:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_903 (insn, operands);

        case 14:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_915 (insn, operands);

        case 15:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_921 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10987 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1027 (insn, operands);

        case 1:
          if (!
#line 11057 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1033 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11106 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
        return NULL;
      return gen_split_1039 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_22 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      if (pattern49 (x1) != 0
          || !
#line 5782 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_514 (insn, operands);

    case REG:
    case SUBREG:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 6611 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_568 (insn, operands);

        case 1:
          if (!
#line 6627 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_569 (insn, operands);

        case 2:
          if (!
#line 6658 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_571 (insn, operands);

        case 3:
          if (!
#line 6642 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_570 (insn, operands);

        case 4:
          if (!
#line 6692 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_573 (insn, operands);

        case 5:
          if (!
#line 6708 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_574 (insn, operands);

        case 6:
          if (!
#line 6721 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_575 (insn, operands);

        case 7:
          if (!
#line 6737 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_576 (insn, operands);

        case 8:
          if (!
#line 6753 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_577 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x3) != E_QImode
          || pattern35 (x1, 
E_QImode, 
24) != 0
          || !
#line 9255 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_651 (insn, operands);

    case POPCOUNT:
      if (GET_MODE (x3) != E_QImode
          || pattern34 (x1, 
E_HImode, 
24) != 0)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_QImode)
          && (
#line 9316 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 9318 "../../gcc/config/avr/avr.md"
( 1)))
        return gen_split_653 (insn, operands);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24
          || GET_MODE (x4) != E_QImode)
        return NULL;
      return gen_split_657 (insn, operands);

    case ZERO_EXTRACT:
      switch (pattern51 (x1))
        {
        case 0:
          if (!(
#line 10647 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10649 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_776 (insn, operands);

        case 1:
          if (!(
#line 10647 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10649 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_777 (insn, operands);

        case 2:
          if (!(
#line 10647 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10649 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_778 (insn, operands);

        case 3:
          if (!(
#line 10647 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10649 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_779 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_25 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case LSHIFTRT:
      if (GET_MODE (x3) != E_HImode)
        return NULL;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MULT
          || GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return NULL;
      x7 = XEXP (x4, 0);
      if (GET_MODE (x7) != E_HImode)
        return NULL;
      x8 = XEXP (x4, 1);
      if (GET_MODE (x8) != E_HImode)
        return NULL;
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x8) != SIGN_EXTEND)
            return NULL;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_QImode))
            return NULL;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_QImode)
              || !(
#line 2269 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2271 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_164 (insn, operands);

        case ZERO_EXTEND:
          if (GET_CODE (x8) != ZERO_EXTEND)
            return NULL;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_QImode))
            return NULL;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_QImode)
              || !(
#line 2269 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2271 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_165 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x3) != E_SImode
          || pattern35 (x1, 
E_SImode, 
22) != 0
          || !
#line 9273 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_652 (insn, operands);

    case POPCOUNT:
      if (GET_MODE (x3) != E_SImode
          || pattern35 (x1, 
E_SImode, 
22) != 0
          || !
#line 9349 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_655 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_30 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern100 (x2, 
26, 
E_HImode) != 0)
    return NULL;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return NULL;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 18
      || GET_MODE (x6) != E_DImode)
    return NULL;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!pseudo_register_operand (operands[0], E_SImode))
    return NULL;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!pseudo_register_operand (operands[1], E_SImode))
    return NULL;
  x11 = XEXP (x9, 1);
  operands[2] = x11;
  if (!pseudo_register_operand (operands[2], E_SImode)
      || !(
#line 3443 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && ! reload_completed) && 
#line 3448 "../../gcc/config/avr/avr.md"
( 1)))
    return NULL;
  return gen_split_313 (insn, operands);
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return NULL;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return NULL;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 22)
    return NULL;
  switch (pattern345 (x1))
    {
    case 0:
      if (!(
#line 3319 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 3321 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_311 (insn, operands);

    case 1:
      if (!(
#line 377 "../../gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL) && 
#line 379 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1835 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_35 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return split_16 (x1, insn);

    case UNSPEC:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XVECLEN (x2, 0))
        {
        case 3:
          switch (pattern67 (x2))
            {
            case 0:
              if (!
#line 1552 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_98 (insn, operands);

            case 1:
              if (!
#line 8944 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_640 (insn, operands);

            case 2:
              if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return NULL;
              return gen_split_1858 (insn, operands);

            case 3:
              if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return NULL;
              return gen_split_1859 (insn, operands);

            case 4:
              if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return NULL;
              return gen_split_1860 (insn, operands);

            case 5:
              if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return NULL;
              return gen_split_1861 (insn, operands);

            case 6:
              if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return NULL;
              return gen_split_1862 (insn, operands);

            case 7:
              if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return NULL;
              return gen_split_1863 (insn, operands);

            case 8:
              if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return NULL;
              return gen_split_1864 (insn, operands);

            case 9:
              if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return NULL;
              return gen_split_1865 (insn, operands);

            case 10:
              if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return NULL;
              return gen_split_1866 (insn, operands);

            case 11:
              if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return NULL;
              return gen_split_1867 (insn, operands);

            default:
              return NULL;
            }

        case 2:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return NULL;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_QImode))
            return NULL;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!register_operand (operands[2], E_QImode))
            return NULL;
          switch (XINT (x2, 1))
            {
            case 4:
              if (!(
#line 9742 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 9744 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_665 (insn, operands);

            case 5:
              if (!(
#line 9814 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 9816 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_667 (insn, operands);

            case 6:
              if (!(
#line 9886 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 9888 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_669 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      return split_12 (x1, insn);

    case MINUS:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 1776 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_107 (insn, operands);

        case 1:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG)
            return NULL;
          switch (pattern72 (x1))
            {
            case 0:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1893 (insn, operands);

            case 1:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1894 (insn, operands);

            case 2:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1895 (insn, operands);

            case 3:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1896 (insn, operands);

            case 4:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1897 (insn, operands);

            case 5:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1898 (insn, operands);

            case 6:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1899 (insn, operands);

            case 7:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1900 (insn, operands);

            case 8:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1901 (insn, operands);

            case 9:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1902 (insn, operands);

            case 10:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1903 (insn, operands);

            case 11:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1904 (insn, operands);

            case 12:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1905 (insn, operands);

            case 13:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1906 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      return split_15 (x1, insn);

    case TRUNCATE:
      return split_25 (x1, insn);

    case ASHIFT:
      return split_19 (x1, insn);

    case AND:
      return split_17 (x1, insn);

    case IOR:
      return split_13 (x1, insn);

    case XOR:
      return split_14 (x1, insn);

    case ROTATE:
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          res = split_8 (x1, insn);
          if (res != NULL_RTX)
            return res;
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 18)
            return NULL;
          switch (pattern87 (x1))
            {
            case 0:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1950 (insn, operands);

            case 1:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1954 (insn, operands);

            case 2:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1958 (insn, operands);

            case 3:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1962 (insn, operands);

            case 4:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1966 (insn, operands);

            case 5:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1970 (insn, operands);

            case 6:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1974 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
          if (XWINT (x6, 0) != -2L
              || pattern73 (x1) != 0
              || !
#line 9080 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_644 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      return split_22 (x1, insn);

    case ASHIFTRT:
      return split_24 (x1, insn);

    case LSHIFTRT:
      return split_20 (x1, insn);

    case ABS:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 6219 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_550 (insn, operands);

        case 1:
          if (!
#line 6239 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_551 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      return split_18 (x1, insn);

    case NOT:
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern56 (x1))
            {
            case 0:
              if (!
#line 6396 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_558 (insn, operands);

            case 1:
              if (!
#line 6414 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_559 (insn, operands);

            case 2:
              if (!
#line 6433 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_560 (insn, operands);

            case 3:
              if (!
#line 6451 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_561 (insn, operands);

            case 4:
              x3 = XEXP (x1, 0);
              x7 = XEXP (x3, 0);
              operands[0] = x7;
              if (!register_operand (operands[0], E_QImode))
                return NULL;
              x8 = XEXP (x3, 2);
              operands[1] = x8;
              if (!const_0_to_7_operand (operands[1], E_QImode)
                  || GET_MODE (x2) != E_QImode)
                return NULL;
              operands[2] = x6;
              if (!register_operand (operands[2], E_QImode)
                  || !
#line 10140 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_675 (insn, operands);

            default:
              return NULL;
            }

        case ROTATE:
          if (pattern57 (x1) != 0
              || !
#line 9067 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_643 (insn, operands);

        case LSHIFTRT:
          if (pattern58 (x1) != 0
              || !
#line 10109 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_672 (insn, operands);

        case ASHIFTRT:
          if (pattern58 (x1) != 0
              || !
#line 10109 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_673 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 6482 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_562 (insn, operands);

        case 1:
          if (!
#line 6503 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_563 (insn, operands);

        case 2:
          if (!
#line 6545 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_565 (insn, operands);

        case 3:
          if (!
#line 6524 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_564 (insn, operands);

        case 4:
          if (!
#line 6566 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_566 (insn, operands);

        case 5:
          if (!
#line 6587 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_567 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      return split_21 (x1, insn);

    case PARITY:
      if (GET_MODE (x2) != E_HImode
          || pattern59 (x1, 
24, 
E_HImode) != 0
          || !
#line 9237 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_650 (insn, operands);

    case POPCOUNT:
      switch (pattern22 (x1))
        {
        case 0:
          if (!
#line 9331 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_654 (insn, operands);

        case 1:
          if (!
#line 9367 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_656 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      if (GET_MODE (x2) != E_SImode
          || pattern59 (x1, 
22, 
E_SImode) != 0
          || !
#line 9635 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_664 (insn, operands);

    case GE:
      if (GET_MODE (x2) != E_QImode)
        return NULL;
      x9 = XEXP (x2, 1);
      if (x9 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
          && pattern95 (x1) == 0
          && 
#line 10156 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_676 (insn, operands);
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern96 (x2))
        {
        case 0:
          if (!
#line 10565 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_755 (insn, operands);

        case 1:
          if (!
#line 10565 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_756 (insn, operands);

        case 2:
          if (!
#line 10565 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_757 (insn, operands);

        case 3:
          if (!
#line 10565 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_758 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      x9 = XEXP (x2, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case XOR:
          if (pattern92 (x1) != 0
              || !(
#line 10172 "../../gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))) && 
#line 10174 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_677 (insn, operands);

        case REG:
        case SUBREG:
          operands[1] = x6;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          switch (pattern181 (x2))
            {
            case 0:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_786 (insn, operands);

            case 1:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_790 (insn, operands);

            case 2:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_794 (insn, operands);

            case 3:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_798 (insn, operands);

            case 4:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_787 (insn, operands);

            case 5:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_791 (insn, operands);

            case 6:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_795 (insn, operands);

            case 7:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_799 (insn, operands);

            case 8:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_788 (insn, operands);

            case 9:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_792 (insn, operands);

            case 10:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_796 (insn, operands);

            case 11:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_800 (insn, operands);

            case 12:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_789 (insn, operands);

            case 13:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_793 (insn, operands);

            case 14:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_797 (insn, operands);

            case 15:
              if (!
#line 10688 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_801 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      return split_23 (x1, insn);

    case FRACT_CONVERT:
      return split_11 (x1, insn);

    case UNSIGNED_FRACT_CONVERT:
      return split_10 (x1, insn);

    case SS_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern61 (x2))
        {
        case 0:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1803 (insn, operands);
          break;

        case 1:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1805 (insn, operands);
          break;

        case 2:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1807 (insn, operands);
          break;

        case 3:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1809 (insn, operands);
          break;

        case 4:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1811 (insn, operands);
          break;

        default:
          break;
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return NULL;
      switch (pattern62 (x1))
        {
        case 0:
          if (!(
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1907 (insn, operands);

        case 1:
          if (!(
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1909 (insn, operands);

        case 2:
          if (!(
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1911 (insn, operands);

        case 3:
          if (!(
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1913 (insn, operands);

        case 4:
          if (!(
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1915 (insn, operands);

        case 5:
          if (!(
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1917 (insn, operands);

        default:
          return NULL;
        }

    case SS_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern61 (x2))
        {
        case 0:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1804 (insn, operands);
          break;

        case 1:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1806 (insn, operands);
          break;

        case 2:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1808 (insn, operands);
          break;

        case 3:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1810 (insn, operands);
          break;

        case 4:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1812 (insn, operands);
          break;

        default:
          break;
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return NULL;
      switch (pattern62 (x1))
        {
        case 0:
          if (!(
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1908 (insn, operands);

        case 1:
          if (!(
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1910 (insn, operands);

        case 2:
          if (!(
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1912 (insn, operands);

        case 3:
          if (!(
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1914 (insn, operands);

        case 4:
          if (!(
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1916 (insn, operands);

        case 5:
          if (!(
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1918 (insn, operands);

        default:
          return NULL;
        }

    case US_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern63 (x2))
        {
        case 0:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1813 (insn, operands);
          break;

        case 1:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1815 (insn, operands);
          break;

        case 2:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1817 (insn, operands);
          break;

        case 3:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1819 (insn, operands);
          break;

        case 4:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1821 (insn, operands);
          break;

        default:
          break;
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return NULL;
      switch (pattern64 (x1))
        {
        case 0:
          if (!(
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1919 (insn, operands);

        case 1:
          if (!(
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1921 (insn, operands);

        case 2:
          if (!(
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1923 (insn, operands);

        case 3:
          if (!(
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1925 (insn, operands);

        case 4:
          if (!(
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1927 (insn, operands);

        case 5:
          if (!(
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1929 (insn, operands);

        default:
          return NULL;
        }

    case US_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern63 (x2))
        {
        case 0:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1814 (insn, operands);
          break;

        case 1:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1816 (insn, operands);
          break;

        case 2:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1818 (insn, operands);
          break;

        case 3:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1820 (insn, operands);
          break;

        case 4:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1822 (insn, operands);
          break;

        default:
          break;
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return NULL;
      switch (pattern64 (x1))
        {
        case 0:
          if (!(
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1920 (insn, operands);

        case 1:
          if (!(
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1922 (insn, operands);

        case 2:
          if (!(
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1924 (insn, operands);

        case 3:
          if (!(
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1926 (insn, operands);

        case 4:
          if (!(
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1928 (insn, operands);

        case 5:
          if (!(
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1930 (insn, operands);

        default:
          return NULL;
        }

    case SS_NEG:
      if (GET_MODE (x2) == E_QQmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_QQmode))
            {
              x6 = XEXP (x2, 0);
              operands[1] = x6;
              if (register_operand (operands[1], E_QQmode)
                  && 
#line 191 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return gen_split_1823 (insn, operands);
            }
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return NULL;
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 243 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1826 (insn, operands);

        case 1:
          if (!
#line 243 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1828 (insn, operands);

        case 2:
          if (!
#line 263 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1830 (insn, operands);

        case 3:
          if (!
#line 263 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1832 (insn, operands);

        default:
          return NULL;
        }

    case SS_ABS:
      if (GET_MODE (x2) == E_QQmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_QQmode))
            {
              x6 = XEXP (x2, 0);
              operands[1] = x6;
              if (register_operand (operands[1], E_QQmode)
                  && 
#line 209 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return gen_split_1824 (insn, operands);
            }
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return NULL;
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 243 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1825 (insn, operands);

        case 1:
          if (!
#line 243 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1827 (insn, operands);

        case 2:
          if (!
#line 263 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1829 (insn, operands);

        case 3:
          if (!
#line 263 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1831 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
