/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern7 (x2, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern7 (x2, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern7 (x2, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern7 (x2, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return 0;

    case SIGN_EXTEND:
      if (pattern16 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case ZERO_EXTEND:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 2);
      operands[2] = x8;
      if (!const0_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode)
            return -1;
          res = pattern9 ();
          if (res >= 0)
            return res + 2; /* [2, 5] */
          return -1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x2) != E_PSImode
              || GET_MODE (x3) != E_PSImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 6; /* [6, 9] */
              return -1;

            case E_HImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 10; /* [10, 13] */
              return -1;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 14; /* [14, 17] */
              return -1;

            case E_HImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 18; /* [18, 21] */
              return -1;

            case E_PSImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 22; /* [22, 25] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      x3 = XEXP (x2, 0);
      res = pattern30 (x3);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != AND
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern61 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      return pattern60 (x1, 
E_QQmode); /* [-1, 0] */

    case E_HQmode:
      if (pattern60 (x1, 
E_HQmode) != 0)
        return -1;
      return 1;

    case E_HAmode:
      if (pattern60 (x1, 
E_HAmode) != 0)
        return -1;
      return 2;

    case E_SAmode:
      if (pattern60 (x1, 
E_SAmode) != 0)
        return -1;
      return 3;

    case E_SQmode:
      if (pattern60 (x1, 
E_SQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      return pattern69 (x1); /* [-1, 6] */

    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 26
          || GET_MODE (x6) != E_QImode
          || GET_MODE (x4) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 7;

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      res = pattern70 (x1);
      if (res >= 0)
        return res + 8; /* [8, 14] */
      return -1;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (!const_0_to_7_operand (operands[2], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  return pattern84 (x1); /* [-1, 5] */
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 3
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != USE
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x8 = XEXP (x4, 2);
  operands[2] = x8;
  if (!const_0_to_7_operand (operands[2], E_QImode))
    return -1;
  x9 = XVECEXP (x6, 0, 0);
  operands[3] = x9;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  x10 = XEXP (x7, 0);
  operands[4] = x10;
  if (!nonmemory_operand (operands[4], E_QImode))
    return -1;
  x11 = XEXP (x4, 0);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      operands[1] = x11;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case NOT:
      if (GET_MODE (x11) != E_QImode)
        return -1;
      x12 = XEXP (x11, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 0);
  operands[3] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_PSImode:
      return pattern112 (x7); /* [-1, 0] */

    case E_HImode:
      if (pattern113 (x7, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_HQmode:
      if (pattern113 (x7, 
E_HQmode) != 0)
        return -1;
      return 2;

    case E_UHQmode:
      if (pattern113 (x7, 
E_UHQmode) != 0)
        return -1;
      return 3;

    case E_HAmode:
      if (pattern113 (x7, 
E_HAmode) != 0)
        return -1;
      return 4;

    case E_UHAmode:
      if (pattern113 (x7, 
E_UHAmode) != 0)
        return -1;
      return 5;

    case E_SImode:
      if (pattern114 (x7, 
E_SImode) != 0)
        return -1;
      return 6;

    case E_SQmode:
      if (pattern114 (x7, 
E_SQmode) != 0)
        return -1;
      return 7;

    case E_USQmode:
      if (pattern114 (x7, 
E_USQmode) != 0)
        return -1;
      return 8;

    case E_SAmode:
      if (pattern114 (x7, 
E_SAmode) != 0)
        return -1;
      return 9;

    case E_USAmode:
      if (pattern114 (x7, 
E_USAmode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 22
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  switch (REGNO (x5))
    {
    case 18:
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 26
              || GET_MODE (x7) != E_HImode)
            return -1;
          return 0;

        case SIGN_EXTEND:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 26
              || GET_MODE (x7) != E_HImode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 26:
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 18)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern140 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 0);
  operands[3] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern139 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern139 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_PSImode:
      if (pattern139 (x1, 
E_PSImode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (pattern139 (x1, 
E_SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern151 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 24
      || GET_MODE (x4) != E_HImode
      || pattern154 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!memory_operand (operands[0], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!memory_operand (operands[0], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!memory_operand (operands[0], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!memory_operand (operands[0], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!memory_operand (operands[0], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!memory_operand (operands[0], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!memory_operand (operands[0], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!memory_operand (operands[0], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!memory_operand (operands[0], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!memory_operand (operands[0], E_USAmode))
        return -1;
      return 12;

    case E_SFmode:
      if (!memory_operand (operands[0], E_SFmode))
        return -1;
      return 13;

    case E_PSImode:
      if (!memory_operand (operands[0], E_PSImode))
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XINT (x2, 1) != 1
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 28
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 28
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PLUS
      || GET_MODE (x9) != E_HImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 28
      || GET_MODE (x10) != E_HImode)
    return -1;
  x11 = XEXP (x8, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 32
      || GET_MODE (x11) != E_HImode)
    return -1;
  return 0;
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XEXP (x3, 0);
  if (REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x10 = XEXP (x2, 0);
  operands[3] = x10;
  if (!scratch_or_dreg_operand (operands[3], E_QImode))
    return -1;
  return pattern187 (x7); /* [-1, 10] */
}

int
pattern195 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !pseudo_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !pseudo_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern200 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern203 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 18
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XEXP (x3, 1);
  if (XWINT (x9, 0) != 16L
      || pattern162 (x1, 
E_HImode, 
24) != 0)
    return -1;
  return 0;
}

int
pattern209 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CCZNmode
      || GET_MODE (x3) != E_CCZNmode)
    return -1;
  x9 = XEXP (x4, 0);
  operands[3] = x9;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  x10 = XEXP (x4, 1);
  operands[4] = x10;
  if (!nonmemory_operand (operands[4], E_QImode))
    return -1;
  x11 = XEXP (x6, 0);
  operands[0] = x11;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x12 = XEXP (x7, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x13 = XEXP (x7, 1);
  operands[2] = x13;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x5) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x7) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x5) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || GET_MODE (x7) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x7) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      return pattern108 (x1, 
E_QQmode); /* [-1, 0] */

    case E_HQmode:
      if (pattern108 (x1, 
E_HQmode) != 0)
        return -1;
      return 1;

    case E_HAmode:
      if (pattern108 (x1, 
E_HAmode) != 0)
        return -1;
      return 2;

    case E_SAmode:
      if (pattern108 (x1, 
E_SAmode) != 0)
        return -1;
      return 3;

    case E_SQmode:
      if (pattern108 (x1, 
E_SQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern248 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 0);
  switch (REGNO (x6))
    {
    case 24:
      switch (REGNO (x4))
        {
        case 22:
          return 0;

        case 18:
          return 1;

        default:
          return -1;
        }

    case 22:
      if (GET_MODE (x6) != E_SImode
          || REGNO (x4) != 18
          || GET_MODE (x4) != E_SImode
          || REGNO (x5) != 18
          || GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 22
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 18
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 22
          || GET_MODE (x11) != E_SImode
          || pattern246 (x1, 
E_SImode, 
E_HImode, 
30, 
26) != 0)
        return -1;
      return 2;

    case 26:
      if (REGNO (x4) != 22
          || REGNO (x5) != 24)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 26
          || GET_MODE (x11) != E_HImode)
        return -1;
      x12 = XVECEXP (x1, 0, 2);
      x13 = XEXP (x12, 0);
      if (REGNO (x13) != 21
          || GET_MODE (x13) != E_QImode)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      if (REGNO (x15) != 36
          || GET_MODE (x15) != E_CCmode)
        return -1;
      res = pattern247 (x2);
      if (res >= 0)
        return res + 3; /* [3, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern264 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern269 (x8, 
E_SImode); /* [-1, 0] */

    case E_PSImode:
      if (pattern269 (x8, 
E_PSImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  return pattern279 (x1); /* [-1, 1] */
}

int
pattern285 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != 3
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 32
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 32
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != UNSPEC_VOLATILE
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 6
      || GET_MODE (x7) != E_BLKmode
      || !const_int_operand (operands[0], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XVECEXP (x8, 0, 1);
  operands[1] = x9;
  if (!const_int_operand (operands[1], E_QImode))
    return -1;
  x10 = XEXP (x6, 0);
  operands[2] = x10;
  x11 = XVECEXP (x7, 0, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 24
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (REGNO (x5) != 25
      || pattern265 (x1, 
24, 
E_HImode, 
22, 
E_HImode) != 0)
    return -1;
  return 0;
}

int
pattern299 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 4:
      return pattern297 (x1); /* [-1, 0] */

    case 5:
      if (pattern297 (x1) != 0)
        return -1;
      return 1;

    case 6:
      if (pattern297 (x1) != 0)
        return -1;
      return 2;

    case 8:
      x4 = XVECEXP (x3, 0, 1);
      if (REGNO (x4) != 24)
        return -1;
      res = pattern298 (x1);
      if (res >= 0)
        return res + 3; /* [3, 12] */
      return -1;

    default:
      return -1;
    }
}

int
pattern303 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern308 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern314 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern318 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!d_register_operand (operands[0], i1)
      || !const_operand (operands[1], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2
      || pattern317 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern321 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 36
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  return pattern324 (x1); /* [-1, 9] */
}

int
pattern330 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!const_8_16_24_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern336 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_DImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern345 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (REGNO (x4))
    {
    case 22:
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 24
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 21
          || GET_MODE (x7) != E_QImode
          || GET_MODE (x3) != E_HImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      if (GET_MODE (x10) != E_HImode)
        return -1;
      return 0;

    case 25:
      if (pattern344 (x1) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern355 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  if (!const0_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern354 (x3); /* [-1, 1] */
}

int
pattern359 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case ZERO_EXTEND:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_QImode)
          || !const_2_to_7_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case SIGN_EXTEND:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_QImode)
          || !const_1_to_6_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern365 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      return pattern364 (x1, 
SIGN_EXTEND); /* [-1, 0] */

    case ZERO_EXTEND:
      if (pattern364 (x1, 
ZERO_EXTEND) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern372 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern375 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i2
      || GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern383 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!d_register_operand (operands[0], i1)
      || !l_register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 2)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x5, 1);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  x9 = XEXP (x5, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_CODE (x2))
    {
    case XOR:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 0;

    case IOR:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 1;

    case AND:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern400 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case GE:
      return pattern394 (x4); /* [-1, 0] */

    case LT:
      if (pattern394 (x4) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) == MEM)
    {
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers != NULL)
    {
      switch (pattern122 (x3))
        {
        case 0:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 68; /* fxloadqi_A */
            }
          break;

        case 1:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 69; /* fxloadqq_A */
            }
          break;

        case 2:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 70; /* fxloaduqq_A */
            }
          break;

        case 3:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 71; /* fxloadhi_A */
            }
          break;

        case 4:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 72; /* fxloadhq_A */
            }
          break;

        case 5:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 73; /* fxloaduhq_A */
            }
          break;

        case 6:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 74; /* fxloadha_A */
            }
          break;

        case 7:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 75; /* fxloaduha_A */
            }
          break;

        case 8:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 76; /* fxloadsi_A */
            }
          break;

        case 9:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 77; /* fxloadsq_A */
            }
          break;

        case 10:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 78; /* fxloadusq_A */
            }
          break;

        case 11:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 79; /* fxloadsa_A */
            }
          break;

        case 12:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 80; /* fxloadusa_A */
            }
          break;

        case 13:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 81; /* fxloadsf_A */
            }
          break;

        case 14:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 82; /* fxloadpsi_A */
            }
          break;

        default:
          break;
        }
    }
  if (pnum_clobbers == NULL
      || GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 21
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode
      || GET_CODE (x2) != REG
      || REGNO (x2) != 22)
    return -1;
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 83; /* fxload_qi_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 98; /* *fxload_qi_libgcc */

    case E_QQmode:
      if (GET_MODE (x3) != E_QQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 84; /* fxload_qq_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 99; /* *fxload_qq_libgcc */

    case E_UQQmode:
      if (GET_MODE (x3) != E_UQQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 85; /* fxload_uqq_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 100; /* *fxload_uqq_libgcc */

    case E_HImode:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 86; /* fxload_hi_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 101; /* *fxload_hi_libgcc */

    case E_HQmode:
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 87; /* fxload_hq_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 102; /* *fxload_hq_libgcc */

    case E_UHQmode:
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 88; /* fxload_uhq_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 103; /* *fxload_uhq_libgcc */

    case E_HAmode:
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 89; /* fxload_ha_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 104; /* *fxload_ha_libgcc */

    case E_UHAmode:
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 90; /* fxload_uha_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 105; /* *fxload_uha_libgcc */

    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 91; /* fxload_si_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 106; /* *fxload_si_libgcc */

    case E_SQmode:
      if (GET_MODE (x3) != E_SQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 92; /* fxload_sq_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 107; /* *fxload_sq_libgcc */

    case E_USQmode:
      if (GET_MODE (x3) != E_USQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 93; /* fxload_usq_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 108; /* *fxload_usq_libgcc */

    case E_SAmode:
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 94; /* fxload_sa_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 109; /* *fxload_sa_libgcc */

    case E_USAmode:
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 95; /* fxload_usa_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 110; /* *fxload_usa_libgcc */

    case E_SFmode:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 96; /* fxload_sf_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 111; /* *fxload_sf_libgcc */

    case E_PSImode:
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 97; /* fxload_psi_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 112; /* *fxload_psi_libgcc */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern39 (x1))
        {
        case 0:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != CONST_INT
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          if (XWINT (x4, 0) == 1L)
            return 526; /* *ashiftqihi2.signx.1_split */
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x4;
          if (const_2_to_6_operand (operands[2], E_HImode)
              && 
#line 3096 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 528; /* *ashifthi3.signx.const */
            }
          if (XWINT (x4, 0) != 7L
              || !
#line 3114 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 529; /* *ashifthi3.signx.const7 */

        case 1:
          if (!
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1445; /* *map.shl.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1447; /* *map.shl.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1451; /* *map.shl.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1449; /* *map.shl.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1453; /* *map.shl.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1455; /* *map.shl.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL
              || pattern124 (x2, 
E_HImode) != 0
              || !const_2_to_7_operand (operands[2], E_HImode)
              || !
#line 3132 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 530; /* *ashifthi3.zerox.const */

        case AND:
          x7 = XEXP (x6, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          switch (pattern37 (x2))
            {
            case 0:
              if (!
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
                return -1;
              return 1446; /* *map.shl.ext.and1-to-skip.hi */

            case 1:
              if (!
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
                return -1;
              return 1448; /* *map.shl.ext.and1-to-skip.psi */

            case 2:
              if (!
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
                return -1;
              return 1452; /* *map.shl.ext.and1-to-skip.psi */

            case 3:
              if (!
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
                return -1;
              return 1450; /* *map.shl.ext.and1-to-skip.si */

            case 4:
              if (!
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
                return -1;
              return 1454; /* *map.shl.ext.and1-to-skip.si */

            case 5:
              if (!
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
                return -1;
              return 1456; /* *map.shl.ext.and1-to-skip.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_16 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 18)
        return -1;
      switch (pattern87 (x1))
        {
        case 0:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3304; /* ashldi3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3332; /* *ashldi3_insn */

        case 1:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3308; /* ashldq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3336; /* *ashldq3_insn */

        case 2:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3312; /* ashludq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3340; /* *ashludq3_insn */

        case 3:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3316; /* ashlda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3344; /* *ashlda3_insn */

        case 4:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3320; /* ashluda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3348; /* *ashluda3_insn */

        case 5:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3324; /* ashlta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3352; /* *ashlta3_insn */

        case 6:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3328; /* ashluta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3356; /* *ashluta3_insn */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 1L
          || pattern73 (x1) != 0)
        return -1;
      return 1013; /* mask1_0x01_split */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern14 (x1))
    {
    case 0:
      return 191; /* *udiff_widenqihi3_split */

    case 1:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      res = recog_8 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern72 (x1))
        {
        case 0:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3196; /* subdi3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3203; /* *subdi3_insn */

        case 1:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3197; /* subdq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3204; /* *subdq3_insn */

        case 2:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3198; /* subudq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3205; /* *subudq3_insn */

        case 3:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3199; /* subda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3206; /* *subda3_insn */

        case 4:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3200; /* subuda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3207; /* *subuda3_insn */

        case 5:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3201; /* subta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3208; /* *subta3_insn */

        case 6:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3202; /* subuta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3209; /* *subuta3_insn */

        case 7:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3210; /* subdi3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3217; /* *subdi3_const_insn */

        case 8:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3211; /* subdq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3218; /* *subdq3_const_insn */

        case 9:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3212; /* subudq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3219; /* *subudq3_const_insn */

        case 10:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3213; /* subda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3220; /* *subda3_const_insn */

        case 11:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3214; /* subuda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3221; /* *subuda3_const_insn */

        case 12:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3215; /* subta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3222; /* *subta3_const_insn */

        case 13:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3216; /* subuta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3223; /* *subuta3_const_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x1, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTRACT:
          if (pattern136 (x1) == 0)
            return 1081; /* *insv.extract */
          break;

        case REG:
        case SUBREG:
          operands[0] = x5;
          operands[1] = x4;
          switch (pattern182 (x2))
            {
            case 0:
              return 1145; /* *extzvqi_split */

            case 1:
              return 1146; /* *extzvhi_split */

            case 2:
              return 1147; /* *extzvpsi_split */

            case 3:
              return 1148; /* *extzvsi_split */

            case 4:
              return 1153; /* *extzv.qihi1 */

            case 5:
              return 1154; /* *extzv.qihi1 */

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG)
        return -1;
      switch (pattern138 (x1))
        {
        case 0:
          if (!
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 0 + INTVAL (operands[3])))
            return -1;
          return 1160; /* *extzv.hi.subreg0 */

        case 1:
          if (!
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 0 + INTVAL (operands[3])))
            return -1;
          return 1164; /* *extzv.psi.subreg0 */

        case 2:
          if (!
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 0 + INTVAL (operands[3])))
            return -1;
          return 1168; /* *extzv.si.subreg0 */

        case 3:
          if (!
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 1 + INTVAL (operands[3])))
            return -1;
          return 1161; /* *extzv.hi.subreg1 */

        case 4:
          if (!
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 1 + INTVAL (operands[3])))
            return -1;
          return 1165; /* *extzv.psi.subreg1 */

        case 5:
          if (!
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 1 + INTVAL (operands[3])))
            return -1;
          return 1169; /* *extzv.si.subreg1 */

        case 6:
          if (!
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 2 + INTVAL (operands[3])))
            return -1;
          return 1162; /* *extzv.hi.subreg2 */

        case 7:
          if (!
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 2 + INTVAL (operands[3])))
            return -1;
          return 1166; /* *extzv.psi.subreg2 */

        case 8:
          if (!
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 2 + INTVAL (operands[3])))
            return -1;
          return 1170; /* *extzv.si.subreg2 */

        case 9:
          if (!
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 3 + INTVAL (operands[3])))
            return -1;
          return 1163; /* *extzv.hi.subreg3 */

        case 10:
          if (!
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 3 + INTVAL (operands[3])))
            return -1;
          return 1167; /* *extzv.psi.subreg3 */

        case 11:
          if (!
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 3 + INTVAL (operands[3])))
            return -1;
          return 1171; /* *extzv.si.subreg3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern93 (x1))
        {
        case 0:
          if (!
#line 10172 "../../gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))))
            return -1;
          return 1091; /* *insv.xor-extract_split */

        case 1:
          if (!
#line 10548 "../../gcc/config/avr/avr.md"
(! reload_completed
   && ((1 << INTVAL (operands[3])) & INTVAL (operands[2])) != 0))
            return -1;
          return 1172; /* *extzv.xor */

        default:
          return -1;
        }

    case NOT:
      if (pattern94 (x1) != 0)
        return -1;
      return 1155; /* *extzv.not_split */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern241 (x1))
        {
        case 0:
          if (
#line 6026 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 746; /* *lshrqi3 */
          break;

        case 1:
          if (
#line 6026 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 747; /* *lshrqq3 */
          break;

        case 2:
          if (
#line 6026 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 748; /* *lshruqq3 */
          break;

        case 3:
          if (
#line 6054 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 754; /* *lshrhi3 */
          break;

        case 4:
          if (
#line 6054 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 755; /* *lshrhq3 */
          break;

        case 5:
          if (
#line 6054 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 756; /* *lshruhq3 */
          break;

        case 6:
          if (
#line 6054 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 757; /* *lshrha3 */
          break;

        case 7:
          if (
#line 6054 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 758; /* *lshruha3 */
          break;

        case 8:
          if (
#line 6113 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 766; /* *lshrsi3 */
          break;

        case 9:
          if (
#line 6113 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 767; /* *lshrsq3 */
          break;

        case 10:
          if (
#line 6113 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 768; /* *lshrusq3 */
          break;

        case 11:
          if (
#line 6113 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 769; /* *lshrsa3 */
          break;

        case 12:
          if (
#line 6113 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 770; /* *lshrusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_PSImode:
      if (pattern112 (x3) != 0)
        return -1;
      return 759; /* lshrpsi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SImode) != 0
          || !
#line 6204 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 776; /* *lshrsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SQmode) != 0
          || !
#line 6204 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 777; /* *lshrsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USQmode) != 0
          || !
#line 6204 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 778; /* *lshrusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SAmode) != 0
          || !
#line 6204 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 779; /* *lshrsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USAmode) != 0
          || !
#line 6204 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 780; /* *lshrusa3_const */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) == REG
          && REGNO (x6) == 36
          && GET_MODE (x6) == E_CCmode)
        {
          x7 = XEXP (x3, 0);
          operands[0] = x7;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern328 (x4, 
E_QImode) == 0
                  && 
#line 2222 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return 301; /* *mulqi3_enh */
              break;

            case E_HImode:
              if (pattern328 (x4, 
E_HImode) == 0
                  && 
#line 3290 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return 538; /* *mulhi3_enh */
              break;

            case E_QQmode:
              if (pattern328 (x4, 
E_QQmode) == 0
                  && 
#line 309 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return 3077; /* *mulqq3_enh */
              break;

            case E_UQQmode:
              if (pattern328 (x4, 
E_UQQmode) == 0
                  && 
#line 330 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return 3079; /* *muluqq3_enh */
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x5) != REG)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != REG)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG
          || GET_CODE (x6) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 24:
          if (pattern287 (x1) != 0
              || !
#line 2243 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            return -1;
          return 302; /* *mulqi3_call_split */

        case 22:
          if (pattern288 (x1) != 0
              || !
#line 3719 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 564; /* *mulsi3_call_split */

        case 18:
          switch (pattern289 (x1))
            {
            case 0:
              if (!
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3082; /* *mulhq3.call_split */

            case 1:
              if (!
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3083; /* *muluhq3.call_split */

            case 2:
              if (!
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3084; /* *mulha3.call_split */

            case 3:
              if (!
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3085; /* *muluha3.call_split */

            default:
              return -1;
            }

        case 16:
          if (REGNO (x8) != 20
              || REGNO (x7) != 24
              || REGNO (x6) != 36
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (pattern278 (x3))
            {
            case 0:
              if (!
#line 481 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 3092; /* *mulsa3.call */

            case 1:
              if (!
#line 481 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 3093; /* *mulusa3.call */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x5) == E_HImode)
        {
          res = recog_43 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (REGNO (x9))
        {
        case 18:
          if (pattern304 (x4, 
E_HImode, 
26, 
E_SImode) != 0
              || pattern305 (x3, 
E_SImode, 
22) != 0
              || !
#line 3792 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 570; /* *mulhisi3_call */

        case 26:
          if (pattern306 (x3, 
E_SImode, 
22, 
18, 
E_HImode) != 0
              || !
#line 3863 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 580; /* *mulshisi3_call */

        case 25:
          if (pattern306 (x3, 
E_PSImode, 
18, 
22, 
E_QImode) != 0
              || !
#line 4242 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 603; /* *mulsqipsi3.libgcc */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      res = recog_44 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != REG
          || pattern184 (x1, 
E_SImode, 
22) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      if (REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x9) != E_HImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      switch (REGNO (x9))
        {
        case 18:
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              x10 = XEXP (x8, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 26
                  || GET_MODE (x10) != E_HImode
                  || !
#line 3792 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 571; /* *umulhisi3_call */

            case SIGN_EXTEND:
              x10 = XEXP (x8, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 26
                  || GET_MODE (x10) != E_HImode
                  || !
#line 3842 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 577; /* *usmulhisi3_call */

            default:
              return -1;
            }

        case 26:
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 18
              || !
#line 3863 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 581; /* *muluhisi3_call */

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != ZERO_EXTEND)
        return -1;
      x11 = XEXP (x9, 0);
      if (GET_CODE (x11) != NOT)
        return -1;
      if (GET_MODE (x11) == E_QImode)
        {
          res = recog_45 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_MODE (x11) != E_HImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 26
          || GET_MODE (x12) != E_HImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 18
          || GET_MODE (x8) != E_SImode
          || pattern154 (x1, 
36, 
E_CCmode, 
E_SImode, 
22) != 0
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x5) != E_SImode
          || GET_MODE (x9) != E_SImode
          || !
#line 3884 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 583; /* *mulohisi3_call */

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (nonmemory_operand (operands[2], E_QImode)
          && pattern267 (x1, 
E_QImode) == 0
          && 
#line 4497 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 619; /* *andqi3 */
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      switch (pattern109 (x4))
        {
        case 0:
          return 620; /* andhi3 */

        case 1:
          return 622; /* andpsi3 */

        case 2:
          return 624; /* andsi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 10634 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1194; /* *insv.any_shift.qi */

        case 1:
          if (!
#line 10634 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1197; /* *insv.any_shift.hi */

        case 2:
          if (!
#line 10634 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1200; /* *insv.any_shift.psi */

        case 3:
          if (!
#line 10634 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1203; /* *insv.any_shift.si */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 10634 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1195; /* *insv.any_shift.qi */

        case 1:
          if (!
#line 10634 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1198; /* *insv.any_shift.hi */

        case 2:
          if (!
#line 10634 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1201; /* *insv.any_shift.psi */

        case 3:
          if (!
#line 10634 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1204; /* *insv.any_shift.si */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 10634 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1196; /* *insv.any_shift.qi */

        case 1:
          if (!
#line 10634 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1199; /* *insv.any_shift.hi */

        case 2:
          if (!
#line 10634 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1202; /* *insv.any_shift.psi */

        case 3:
          if (!
#line 10634 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1205; /* *insv.any_shift.si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern97 (x1))
        {
        case 0:
          if (!
#line 11009 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1478; /* *nzb=1.and.zerox */

        case 1:
          if (!
#line 11129 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1493; /* *nzb=1.and.zerox.not */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_59 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_57 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_55 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_64 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_58 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_67 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_63 (x1, insn, pnum_clobbers);

    case DIV:
      if (pnum_clobbers != NULL)
        {
          switch (pattern140 (x1, 
MOD))
            {
            case 0:
              *pnum_clobbers = 4;
              return 584; /* divmodqi4 */

            case 1:
              *pnum_clobbers = 4;
              return 590; /* divmodhi4 */

            case 2:
              *pnum_clobbers = 2;
              return 606; /* divmodpsi4 */

            case 3:
              *pnum_clobbers = 4;
              return 612; /* divmodsi4 */

            default:
              break;
            }
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern145 (x1, pnum_clobbers, 
MOD))
        {
        case 0:
          *pnum_clobbers = 2;
          return 585; /* *divmodqi4_call_split */

        case 1:
          *pnum_clobbers = 2;
          return 591; /* *divmodhi4_call_split */

        case 2:
          *pnum_clobbers = 3;
          return 607; /* *divmodpsi4_call_split */

        case 3:
          *pnum_clobbers = 2;
          return 613; /* *divmodsi4_call_split */

        case 4:
          return 3095; /* *divqq3.call_split */

        case 5:
          return 3097; /* *divuqq3.call_split */

        default:
          return -1;
        }

    case UDIV:
      if (pnum_clobbers != NULL)
        {
          switch (pattern140 (x1, 
UMOD))
            {
            case 0:
              *pnum_clobbers = 4;
              return 587; /* udivmodqi4 */

            case 1:
              *pnum_clobbers = 4;
              return 593; /* udivmodhi4 */

            case 2:
              *pnum_clobbers = 2;
              return 609; /* udivmodpsi4 */

            case 3:
              *pnum_clobbers = 4;
              return 615; /* udivmodsi4 */

            default:
              break;
            }
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern145 (x1, pnum_clobbers, 
UMOD))
        {
        case 0:
          *pnum_clobbers = 1;
          return 588; /* *udivmodqi4_call_split */

        case 1:
          *pnum_clobbers = 2;
          return 594; /* *udivmodhi4_call_split */

        case 2:
          *pnum_clobbers = 3;
          return 610; /* *udivmodpsi4_call_split */

        case 3:
          *pnum_clobbers = 2;
          return 616; /* *udivmodsi4_call_split */

        case 4:
          return 3094; /* *udivqq3.call_split */

        case 5:
          return 3096; /* *udivuqq3.call_split */

        default:
          return -1;
        }

    case AND:
      return recog_65 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern98 (x1, pnum_clobbers))
        {
        case 0:
          if (nonmemory_operand (operands[2], E_QImode)
              && pattern267 (x1, 
E_QImode) == 0
              && 
#line 4647 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 627; /* *iorqi3 */
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          switch (pattern109 (x3))
            {
            case 0:
              return 628; /* iorhi3 */

            case 1:
              return 630; /* iorpsi3 */

            case 2:
              return 632; /* iorsi3 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 11009 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1477; /* *nzb=1.ior.zerox */

        case 2:
          if (!
#line 11129 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1492; /* *nzb=1.ior.zerox.not */

        default:
          return -1;
        }

    case XOR:
      switch (pattern98 (x1, pnum_clobbers))
        {
        case 0:
          if (register_operand (operands[2], E_QImode)
              && pattern267 (x1, 
E_QImode) == 0
              && 
#line 4771 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 635; /* *xorqi3 */
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          switch (pattern109 (x3))
            {
            case 0:
              return 636; /* xorhi3 */

            case 1:
              return 638; /* xorpsi3 */

            case 2:
              return 640; /* xorsi3 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 11009 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1476; /* *nzb=1.xor.zerox */

        case 2:
          if (!
#line 11129 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1491; /* *nzb=1.xor.zerox.not */

        default:
          return -1;
        }

    case ROTATE:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          res = recog_47 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x4) != REG)
            return -1;
          switch (pattern170 (x1))
            {
            case 0:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3335; /* *rotldi3_insn */

            case 1:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3339; /* *rotldq3_insn */

            case 2:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3343; /* *rotludq3_insn */

            case 3:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3347; /* *rotlda3_insn */

            case 4:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3351; /* *rotluda3_insn */

            case 5:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3355; /* *rotlta3_insn */

            case 6:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3359; /* *rotluta3_insn */

            default:
              return -1;
            }

        case CONST_INT:
          if (pattern169 (x1, 
E_QImode) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          operands[1] = x7;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          switch (XWINT (x4, 0))
            {
            case 1L:
              if (!
#line 9015 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1014; /* *mask1_0x01 */

            case -2L:
              if (!
#line 9091 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1019; /* *mask1_0xfe */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      res = recog_48 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3333; /* *ashrdi3_insn */

        case 1:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3337; /* *ashrdq3_insn */

        case 2:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3341; /* *ashrudq3_insn */

        case 3:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3345; /* *ashrda3_insn */

        case 4:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3349; /* *ashruda3_insn */

        case 5:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3353; /* *ashrta3_insn */

        case 6:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3357; /* *ashruta3_insn */

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3334; /* *lshrdi3_insn */

        case 1:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3338; /* *lshrdq3_insn */

        case 2:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3342; /* *lshrudq3_insn */

        case 3:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3346; /* *lshrda3_insn */

        case 4:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3350; /* *lshruda3_insn */

        case 5:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3354; /* *lshrta3_insn */

        case 6:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3358; /* *lshruta3_insn */

        default:
          return -1;
        }

    case ABS:
      if (pattern99 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 6228 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 782; /* *absqi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 6248 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 784; /* *abssf2 */

        default:
          return -1;
        }

    case NEG:
      return recog_61 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_62 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_69 (x1, insn, pnum_clobbers);

    case LO_SUM:
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern171 (x1) != 0)
        return -1;
      return 822; /* n_extendhipsi2 */

    case COMPARE:
      return recog_56 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_60 (x1, insn, pnum_clobbers);

    case CALL:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!nonmemory_operand (operands[1], E_HImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (!general_operand (operands[2], E_HImode))
        return -1;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_HImode))
        return -1;
      return 971; /* call_value_insn */

    case ROTATERT:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != CONST_INT
          || XWINT (x4, 0) != -128L)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern211 (x1, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode)
          || !
#line 9048 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1016; /* *mask1_0x80 */

    case PARITY:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      if (REGNO (x6) == 24)
        {
          switch (pattern229 (x1))
            {
            case 0:
              if (
#line 9179 "../../gcc/config/avr/avr.md"
(!reload_completed))
                return 1022; /* *parityhi2 */
              break;

            case 1:
              if (
#line 9208 "../../gcc/config/avr/avr.md"
(!reload_completed))
                return 1024; /* *parityqihi2.2 */
              break;

            default:
              break;
            }
        }
      if (REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24
          || GET_MODE (x4) != E_HImode)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24
          || GET_MODE (x8) != E_HImode
          || !
#line 9246 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1026; /* *parityhi2.libgcc */

    case ZERO_EXTEND:
      return recog_70 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24
          || pattern172 (x1, 
36, 
24, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      switch (GET_MODE (x8))
        {
        case E_HImode:
          if (GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_HImode
              || !
#line 9340 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1033; /* *popcounthi2.libgcc */

        case E_QImode:
          if (GET_MODE (x3) != E_QImode
              || GET_MODE (x4) != E_QImode
              || !
#line 9376 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1037; /* *popcountqi2.libgcc */

        default:
          return -1;
        }

    case CLZ:
      if (pattern101 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
        return -1;
      return 1039; /* *clzhi2.libgcc_split */

    case CTZ:
      if (pattern101 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
        return -1;
      return 1043; /* *ctzhi2.libgcc_split */

    case FFS:
      if (pattern101 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
        return -1;
      return 1047; /* *ffshi2.libgcc_split */

    case BSWAP:
      if (pattern101 (x1, 
36, 
E_CCmode, 
E_SImode, 
22) != 0
          || !
#line 9644 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1053; /* *bswapsi2.libgcc */

    case ZERO_EXTRACT:
      return recog_68 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      return recog_66 (x1, insn, pnum_clobbers);

    case FRACT_CONVERT:
      return recog_54 (x1, insn, pnum_clobbers);

    case UNSIGNED_FRACT_CONVERT:
      return recog_53 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (pattern242 (x3))
        {
        case 0:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3026; /* *ssaddqq3 */
          break;

        case 1:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3028; /* *ssaddhq3 */
          break;

        case 2:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3030; /* *ssaddha3 */
          break;

        case 3:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3032; /* *ssaddsa3 */
          break;

        case 4:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3034; /* *ssaddsq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern243 (x2))
        {
        case 0:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3230; /* *ssadddq3_insn */

        case 1:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3232; /* *ssaddda3_insn */

        case 2:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3234; /* *ssaddta3_insn */

        case 3:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3242; /* *ssadddq3_const_insn */

        case 4:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3244; /* *ssaddda3_const_insn */

        case 5:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3246; /* *ssaddta3_const_insn */

        default:
          return -1;
        }

    case SS_MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (pattern242 (x3))
        {
        case 0:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3027; /* *sssubqq3 */
          break;

        case 1:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3029; /* *sssubhq3 */
          break;

        case 2:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3031; /* *sssubha3 */
          break;

        case 3:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3033; /* *sssubsa3 */
          break;

        case 4:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3035; /* *sssubsq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern243 (x2))
        {
        case 0:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3231; /* *sssubdq3_insn */

        case 1:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3233; /* *sssubda3_insn */

        case 2:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3235; /* *sssubta3_insn */

        case 3:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3243; /* *sssubdq3_const_insn */

        case 4:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3245; /* *sssubda3_const_insn */

        case 5:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3247; /* *sssubta3_const_insn */

        default:
          return -1;
        }

    case US_PLUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (pattern244 (x3))
        {
        case 0:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3046; /* *usadduqq3 */
          break;

        case 1:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3048; /* *usadduhq3 */
          break;

        case 2:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3050; /* *usadduha3 */
          break;

        case 3:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3052; /* *usaddusa3 */
          break;

        case 4:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3054; /* *usaddusq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern245 (x2))
        {
        case 0:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3254; /* *usaddudq3_insn */

        case 1:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3256; /* *usadduda3_insn */

        case 2:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3258; /* *usadduta3_insn */

        case 3:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3266; /* *usaddudq3_const_insn */

        case 4:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3268; /* *usadduda3_const_insn */

        case 5:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3270; /* *usadduta3_const_insn */

        default:
          return -1;
        }

    case US_MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (pattern244 (x3))
        {
        case 0:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3047; /* *ussubuqq3 */
          break;

        case 1:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3049; /* *ussubuhq3 */
          break;

        case 2:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3051; /* *ussubuha3 */
          break;

        case 3:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3053; /* *ussubusa3 */
          break;

        case 4:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3055; /* *ussubusq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern245 (x2))
        {
        case 0:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3255; /* *ussubudq3_insn */

        case 1:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3257; /* *ussubuda3_insn */

        case 2:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3259; /* *ussubuta3_insn */

        case 3:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3267; /* *ussubudq3_const_insn */

        case 4:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3269; /* *ussubuda3_const_insn */

        case 5:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3271; /* *ussubuta3_const_insn */

        default:
          return -1;
        }

    case SS_NEG:
      if (GET_MODE (x3) == E_QQmode
          && pattern146 (x1) == 0
          && 
#line 200 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return 3057; /* *ssnegqq2 */
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 252 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3065; /* *ssneghq2 */

        case 1:
          if (!
#line 252 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3067; /* *ssnegha2 */

        case 2:
          if (!
#line 272 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3073; /* *ssnegsa2 */

        case 3:
          if (!
#line 272 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3075; /* *ssnegsq2 */

        default:
          return -1;
        }

    case SS_ABS:
      if (GET_MODE (x3) == E_QQmode
          && pattern146 (x1) == 0
          && 
#line 218 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return 3059; /* *ssabsqq2 */
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 252 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3064; /* *ssabshq2 */

        case 1:
          if (!
#line 252 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3066; /* *ssabsha2 */

        case 2:
          if (!
#line 272 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3072; /* *ssabssa2 */

        case 3:
          if (!
#line 272 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3074; /* *ssabssq2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (pattern151 (x3) != 0
          || !
#line 4636 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_371 (insn, operands);

    case LSHIFTRT:
      switch (pattern80 (x3))
        {
        case 0:
          if (!(
#line 10191 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10193 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_680 (insn, operands);

        case 1:
          if (!(
#line 10191 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10193 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_684 (insn, operands);

        case 2:
          if (!(
#line 10191 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10193 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_688 (insn, operands);

        case 3:
          if (!
#line 11031 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1031 (insn, operands);

        case 4:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_704 (insn, operands);

        case 5:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_708 (insn, operands);

        case 6:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_716 (insn, operands);

        case 7:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_712 (insn, operands);

        case 8:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_720 (insn, operands);

        case 9:
          if (!(
#line 10237 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_724 (insn, operands);

        case 10:
          if (!
#line 11082 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1037 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern82 (x3))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern78 (x3, 
E_HImode) == 0
                  && (
#line 10191 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10193 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_682 (insn, operands);
              break;

            case E_PSImode:
              if (pattern78 (x3, 
E_PSImode) == 0
                  && (
#line 10191 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10193 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_686 (insn, operands);
              break;

            case E_SImode:
              if (pattern78 (x3, 
E_SImode) == 0
                  && (
#line 10191 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10193 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_690 (insn, operands);
              break;

            case E_QImode:
              if (pattern79 (x3) == 0
                  && 
#line 11151 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
                return gen_split_1042 (insn, operands);
              break;

            default:
              break;
            }
          x5 = XEXP (x4, 1);
          if (XWINT (x5, 0) != 8L
              || pattern222 (x3) != 0
              || !(
#line 10303 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10305 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_731 (insn, operands);

        case 1:
          x5 = XEXP (x4, 1);
          operands[3] = x5;
          switch (pattern46 (x3))
            {
            case 0:
              if ((
#line 10237 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_706 (insn, operands);
              break;

            case 1:
              if ((
#line 10237 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_710 (insn, operands);
              break;

            case 2:
              if ((
#line 10237 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_718 (insn, operands);
              break;

            case 3:
              if ((
#line 10237 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_714 (insn, operands);
              break;

            case 4:
              if ((
#line 10237 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_722 (insn, operands);
              break;

            case 5:
              if ((
#line 10237 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10240 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_726 (insn, operands);
              break;

            default:
              break;
            }
          if (XWINT (x5, 0) != 8L)
            return NULL;
          switch (pattern234 (x3))
            {
            case 0:
              if (!(
#line 10254 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10256 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_728 (insn, operands);

            case 1:
              if (!(
#line 10287 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10289 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_730 (insn, operands);

            default:
              return NULL;
            }

        case 2:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_925 (insn, operands);

        case 3:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_931 (insn, operands);

        case 4:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_943 (insn, operands);

        case 5:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_937 (insn, operands);

        case 6:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_949 (insn, operands);

        case 7:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_955 (insn, operands);

        case 8:
          if (!(
#line 10254 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10256 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_727 (insn, operands);

        case 9:
          if (!(
#line 10287 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10289 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_729 (insn, operands);

        case 10:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_924 (insn, operands);

        case 11:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_930 (insn, operands);

        case 12:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_942 (insn, operands);

        case 13:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_936 (insn, operands);

        case 14:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_948 (insn, operands);

        case 15:
          if (!(
#line 10833 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10837 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_954 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (pattern3 (x3))
        {
        case 0:
          if (!(
#line 10214 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 10216 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_692 (insn, operands);

        case 1:
          if (!(
#line 10214 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 10216 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_694 (insn, operands);

        case 2:
          if (!(
#line 10214 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 10216 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_698 (insn, operands);

        case 3:
          if (!(
#line 10214 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 10216 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_696 (insn, operands);

        case 4:
          if (!(
#line 10214 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 10216 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_700 (insn, operands);

        case 5:
          if (!(
#line 10214 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 10216 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_702 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x3))
            {
            case 0:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_827 (insn, operands);

            case 1:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_839 (insn, operands);

            case 2:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_851 (insn, operands);

            case 3:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_863 (insn, operands);

            case 4:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_830 (insn, operands);

            case 5:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_842 (insn, operands);

            case 6:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_854 (insn, operands);

            case 7:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_866 (insn, operands);

            case 8:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_833 (insn, operands);

            case 9:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_845 (insn, operands);

            case 10:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_857 (insn, operands);

            case 11:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_869 (insn, operands);

            case 12:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_836 (insn, operands);

            case 13:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_848 (insn, operands);

            case 14:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_860 (insn, operands);

            case 15:
              if (!(
#line 10771 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10774 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_872 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern12 (x3))
            {
            case 0:
              if (!(
#line 10852 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10857 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_959 (insn, operands);

            case 1:
              if (!(
#line 10852 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10857 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_962 (insn, operands);

            case 2:
              if (!(
#line 10852 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10857 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_965 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      switch (pattern86 (x3))
        {
        case 0:
          if (!(
#line 10796 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10799 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_875 (insn, operands);

        case 1:
          if (!(
#line 10796 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10799 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_878 (insn, operands);

        case 2:
          if (!(
#line 10796 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10799 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_881 (insn, operands);

        case 3:
          if (!(
#line 10796 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10799 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_884 (insn, operands);

        case 4:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_888 (insn, operands);

        case 5:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_894 (insn, operands);

        case 6:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_906 (insn, operands);

        case 7:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_900 (insn, operands);

        case 8:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_912 (insn, operands);

        case 9:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_918 (insn, operands);

        case 10:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_889 (insn, operands);

        case 11:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_895 (insn, operands);

        case 12:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_907 (insn, operands);

        case 13:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_901 (insn, operands);

        case 14:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_913 (insn, operands);

        case 15:
          if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10817 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_919 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      switch (pattern120 (x3))
        {
        case 0:
          if (!
#line 10987 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1028 (insn, operands);

        case 1:
          if (!
#line 11057 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1034 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      if (pattern121 (x3) != 0
          || !
#line 11106 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
        return NULL;
      return gen_split_1040 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_21 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[0] = x3;
      if (ordered_comparison_operator (operands[0], E_VOIDmode))
        {
          res = split_9 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern91 (x1))
        {
        case 0:
          if (!
#line 7670 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_619 (insn, operands);

        case 1:
          if (!
#line 7670 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_620 (insn, operands);

        case 2:
          if (!
#line 7670 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_621 (insn, operands);

        case 3:
          if (!
#line 7670 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_622 (insn, operands);

        case 4:
          if (!
#line 7670 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_623 (insn, operands);

        case 5:
          if (low_io_address_operand (operands[1], E_VOIDmode)
              && 
#line 8184 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_630 (insn, operands);
          if (!high_io_address_operand (operands[1], E_VOIDmode)
              || !
#line 8279 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_633 (insn, operands);

        case 6:
          if (low_io_address_operand (operands[1], E_VOIDmode)
              && 
#line 8184 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_631 (insn, operands);
          if (!high_io_address_operand (operands[1], E_VOIDmode)
              || !
#line 8279 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_634 (insn, operands);

        case 7:
          if (!
#line 7723 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_624 (insn, operands);

        case 8:
          if (!
#line 7723 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_625 (insn, operands);

        case 9:
          if (!
#line 7723 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_626 (insn, operands);

        case 10:
          if (!
#line 7723 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_627 (insn, operands);

        case 11:
          operands[0] = x3;
          if (gelt_operator (operands[0], E_VOIDmode))
            {
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) == MEM
                  && GET_MODE (x5) == E_QImode)
                {
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  x7 = XEXP (x2, 1);
                  x8 = XEXP (x7, 0);
                  operands[2] = x8;
                  if (low_io_address_operand (operands[1], E_VOIDmode)
                      && 
#line 8232 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return gen_split_632 (insn, operands);
                  if (high_io_address_operand (operands[1], E_VOIDmode)
                      && 
#line 8326 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return gen_split_635 (insn, operands);
                }
            }
          if (GET_CODE (x3) != GE)
            return NULL;
          x5 = XEXP (x3, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          x7 = XEXP (x2, 1);
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!
#line 9128 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_645 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_27 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (!scratch_operand (x5, E_QImode))
    return NULL;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern314 (x6, 
E_HImode) != 0
              || !
#line 1911 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_114 (insn, operands);

        case E_HQmode:
          if (pattern314 (x6, 
E_HQmode) != 0
              || !
#line 1911 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_115 (insn, operands);

        case E_UHQmode:
          if (pattern314 (x6, 
E_UHQmode) != 0
              || !
#line 1911 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_116 (insn, operands);

        case E_HAmode:
          if (pattern314 (x6, 
E_HAmode) != 0
              || !
#line 1911 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_117 (insn, operands);

        case E_UHAmode:
          if (pattern314 (x6, 
E_UHAmode) != 0
              || !
#line 1911 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_118 (insn, operands);

        case E_SImode:
          if (pattern108 (x6, 
E_SImode) != 0
              || !
#line 1945 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_119 (insn, operands);

        case E_SQmode:
          if (pattern108 (x6, 
E_SQmode) != 0
              || !
#line 1945 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_120 (insn, operands);

        case E_USQmode:
          if (pattern108 (x6, 
E_USQmode) != 0
              || !
#line 1945 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_121 (insn, operands);

        case E_SAmode:
          if (pattern108 (x6, 
E_SAmode) != 0
              || !
#line 1945 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_122 (insn, operands);

        case E_USAmode:
          if (pattern108 (x6, 
E_USAmode) != 0
              || !
#line 1945 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_123 (insn, operands);

        case E_PSImode:
          if (pattern108 (x6, 
E_PSImode) != 0
              || !
#line 2055 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_147 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      operands[4] = x5;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          if (pattern237 (x6) != 0
              || !const_int_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_QImode)
              || !(
#line 2649 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2651 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_279 (insn, operands);

        case SIGN_EXTEND:
          if (pattern238 (x6) != 0)
            return NULL;
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2859 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2861 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_290 (insn, operands);
          if (!u8_operand (operands[2], E_HImode)
              || !(
#line 2951 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)) && 
#line 2954 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_296 (insn, operands);

        case ZERO_EXTEND:
          if (GET_MODE (x10) != E_HImode
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x6) != E_HImode
              || GET_MODE (x7) != E_HImode)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_QImode)
              || !u8_operand (operands[2], E_HImode)
              || !register_operand (operands[3], E_HImode)
              || !(
#line 2859 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2861 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_291 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_35 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_33 (x1, insn);

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case SUBREG:
            case MEM:
              operands[1] = x5;
              switch (pattern212 (x1))
                {
                case 0:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_32 (insn, operands);

                case 1:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_33 (insn, operands);

                case 2:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_34 (insn, operands);

                case 3:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_35 (insn, operands);

                case 4:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_36 (insn, operands);

                case 5:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_37 (insn, operands);

                case 6:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_38 (insn, operands);

                case 7:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_39 (insn, operands);

                case 8:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_40 (insn, operands);

                case 9:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_41 (insn, operands);

                case 10:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_42 (insn, operands);

                case 11:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_43 (insn, operands);

                case 12:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_44 (insn, operands);

                case 13:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_45 (insn, operands);

                case 14:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_46 (insn, operands);

                default:
                  return NULL;
                }

            case MULT:
              if (GET_MODE (x5) == E_SImode)
                {
                  res = split_30 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                }
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != REG
                  || pattern149 (x2) != 0
                  || pattern173 (x1) != 0)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_MODE (x7) != E_HImode)
                return NULL;
              switch (pattern367 (x1))
                {
                case 0:
                  if (!(
#line 3735 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY) && 
#line 3739 "../../gcc/config/avr/avr.md"
( reload_completed)))
                    return NULL;
                  return gen_split_336 (insn, operands);

                case 1:
                  if (!(
#line 4253 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4255 "../../gcc/config/avr/avr.md"
( reload_completed)))
                    return NULL;
                  return gen_split_358 (insn, operands);

                default:
                  return NULL;
                }

            case DIV:
              x8 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x8) != SET)
                return NULL;
              x9 = XEXP (x8, 1);
              if (GET_CODE (x9) != MOD)
                return NULL;
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != REG)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG)
                return NULL;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) == REG)
                {
                  res = split_31 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                }
              if (REGNO (x7) != 26
                  || GET_MODE (x7) != E_QImode
                  || REGNO (x10) != 18
                  || GET_MODE (x10) != E_DImode
                  || pattern343 (x1) != 0)
                return NULL;
              return gen_split_359 (insn, operands);

            case UDIV:
              x8 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x8) != SET)
                return NULL;
              x9 = XEXP (x8, 1);
              if (GET_CODE (x9) != UMOD)
                return NULL;
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != REG)
                return NULL;
              if (REGNO (x10) == 26
                  && GET_MODE (x10) == E_HImode)
                {
                  x6 = XEXP (x5, 0);
                  if (GET_CODE (x6) == REG
                      && pattern300 (x1) == 0)
                    {
                      x7 = XEXP (x4, 0);
                      if (GET_CODE (x7) == REG)
                        {
                          switch (REGNO (x6))
                            {
                            case 24:
                              if (pattern377 (x1, 
E_HImode, 
E_QImode, 
21, 
24, 
22) == 0
                                  && 
#line 4061 "../../gcc/config/avr/avr.md"
( reload_completed))
                                return gen_split_352 (insn, operands);
                              break;

                            case 22:
                              if (pattern377 (x1, 
E_SImode, 
E_HImode, 
30, 
22, 
18) == 0
                                  && 
#line 4460 "../../gcc/config/avr/avr.md"
( reload_completed))
                                return gen_split_366 (insn, operands);
                              break;

                            default:
                              break;
                            }
                        }
                    }
                }
              if (REGNO (x10) != 18
                  || GET_MODE (x10) != E_DImode)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 26
                  || GET_MODE (x7) != E_QImode
                  || pattern343 (x1) != 0)
                return NULL;
              return gen_split_361 (insn, operands);

            case UNSPEC:
              if (pattern119 (x1) != 0)
                return NULL;
              x7 = XEXP (x4, 0);
              if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x11 = XVECEXP (x5, 0, 0);
                  operands[0] = x11;
                  if (register_operand (operands[0], E_HImode))
                    {
                      x8 = XVECEXP (x1, 0, 1);
                      x12 = XEXP (x8, 0);
                      x13 = XEXP (x12, 0);
                      operands[1] = x13;
                      x10 = XEXP (x3, 0);
                      operands[2] = x10;
                      if (scratch_operand (operands[2], E_HImode)
                          && (
#line 7968 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL) && 
#line 7970 "../../gcc/config/avr/avr.md"
( reload_completed)))
                        return gen_split_628 (insn, operands);
                    }
                }
              x11 = XVECEXP (x5, 0, 0);
              if (GET_CODE (x11) != REG
                  || pattern332 (x1) != 0
                  || !(
#line 8004 "../../gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL) && 
#line 8006 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_629 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          return split_34 (x1, insn);

        case 7:
          if (pattern28 (x1) != 0)
            return NULL;
          switch (pattern392 (x1))
            {
            case 0:
              if (!
#line 1328 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_92 (insn, operands);

            case 1:
              if (!
#line 1328 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_93 (insn, operands);

            default:
              return NULL;
            }

        case 9:
          switch (pattern29 (x1))
            {
            case 0:
              if (!
#line 1384 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_94 (insn, operands);

            case 1:
              if (!
#line 1384 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_95 (insn, operands);

            default:
              return NULL;
            }

        case 5:
          x4 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x14 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x14) != CLOBBER)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x5 = XEXP (x2, 1);
              switch (GET_CODE (x5))
                {
                case CONST_INT:
                  if (XWINT (x5, 0) != 0L
                      || pattern174 (x1) != 0)
                    return NULL;
                  switch (pattern294 (x1))
                    {
                    case 0:
                      if (!
#line 1463 "../../gcc/config/avr/avr.md"
( reload_completed))
                        return NULL;
                      return gen_split_96 (insn, operands);

                    case 1:
                      if (!
#line 1494 "../../gcc/config/avr/avr.md"
( reload_completed))
                        return NULL;
                      return gen_split_97 (insn, operands);

                    default:
                      return NULL;
                    }

                case DIV:
                  if (pattern190 (x1, 
MOD) != 0
                      || !
#line 4313 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return NULL;
                  return gen_split_360 (insn, operands);

                case UDIV:
                  if (pattern190 (x1, 
UMOD) != 0
                      || !
#line 4362 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return NULL;
                  return gen_split_362 (insn, operands);

                default:
                  return NULL;
                }

            case UNSPEC_VOLATILE:
              if (pattern157 (x1, 
3) != 0
                  || pattern254 (x1) != 0
                  || !
#line 8855 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_638 (insn, operands);

            default:
              return NULL;
            }

        case 6:
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x14 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x14) != CLOBBER)
            return NULL;
          x15 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x15) != CLOBBER)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != REG)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG)
                return NULL;
              x16 = XEXP (x14, 0);
              if (GET_CODE (x16) != REG)
                return NULL;
              x17 = XEXP (x15, 0);
              if (GET_CODE (x17) != REG)
                return NULL;
              x18 = XEXP (x2, 0);
              operands[0] = x18;
              x12 = XEXP (x8, 0);
              operands[3] = x12;
              x5 = XEXP (x2, 1);
              switch (GET_CODE (x5))
                {
                case DIV:
                  switch (pattern351 (x1, 
MOD))
                    {
                    case 0:
                      return gen_split_345 (insn, operands);

                    case 1:
                      return gen_split_349 (insn, operands);

                    case 2:
                      return gen_split_363 (insn, operands);

                    default:
                      return NULL;
                    }

                case UDIV:
                  switch (pattern351 (x1, 
UMOD))
                    {
                    case 0:
                      return gen_split_347 (insn, operands);

                    case 1:
                      return gen_split_351 (insn, operands);

                    case 2:
                      return gen_split_365 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x2, 0) != 2
                  || XINT (x2, 1) != 10)
                return NULL;
              x19 = XVECEXP (x2, 0, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
                return NULL;
              x9 = XEXP (x8, 1);
              if (pattern103 (x9) != 0
                  || pattern352 (x1) != 0
                  || !
#line 8898 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_639 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return peephole2_6 (x1, insn, pmatch_len_);

        case 3:
          if (peep2_current_count < 2)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XVECEXP (x1, 0, 2);
          if (pattern116 (x4) != 0)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 2)
            return NULL;
          x7 = XVECEXP (x6, 0, 0);
          if (GET_CODE (x7) != SET)
            return NULL;
          x8 = XVECEXP (x6, 0, 1);
          if (GET_CODE (x8) != CLOBBER)
            return NULL;
          x9 = XEXP (x2, 1);
          switch (GET_CODE (x9))
            {
            case CONST_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
              operands[1] = x9;
              x10 = XEXP (x3, 0);
              operands[2] = x10;
              if (!d_register_operand (operands[2], E_QImode))
                return NULL;
              x11 = XEXP (x7, 1);
              if (GET_CODE (x11) != PLUS)
                return NULL;
              x12 = XEXP (x8, 0);
              if (GET_CODE (x12) != REG
                  || REGNO (x12) != 36
                  || GET_MODE (x12) != E_CCmode)
                return NULL;
              x13 = XEXP (x7, 0);
              operands[3] = x13;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[3]))
                return NULL;
              x15 = XEXP (x11, 1);
              if (!rtx_equal_p (x15, operands[0]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern391 (x11, 
E_HImode) != 0
                      || !
#line 1894 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_37 (insn, operands);

                case E_HQmode:
                  if (pattern391 (x11, 
E_HQmode) != 0
                      || !
#line 1894 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_38 (insn, operands);

                case E_UHQmode:
                  if (pattern391 (x11, 
E_UHQmode) != 0
                      || !
#line 1894 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_39 (insn, operands);

                case E_HAmode:
                  if (pattern391 (x11, 
E_HAmode) != 0
                      || !
#line 1894 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_40 (insn, operands);

                case E_UHAmode:
                  if (pattern391 (x11, 
E_UHAmode) != 0
                      || !
#line 1894 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_41 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              if (peep2_current_count < 3)
                return NULL;
              x16 = XEXP (x9, 1);
              operands[1] = x16;
              x10 = XEXP (x3, 0);
              operands[3] = x10;
              if (!scratch_or_dreg_operand (operands[3], E_QImode))
                return NULL;
              x17 = XEXP (x9, 0);
              if (pattern378 (x17) != 0)
                return NULL;
              x12 = XEXP (x8, 0);
              if (GET_CODE (x12) != SCRATCH
                  || GET_MODE (x12) != E_QImode)
                return NULL;
              x11 = XEXP (x7, 1);
              x15 = XEXP (x11, 1);
              operands[4] = x15;
              x14 = XEXP (x11, 0);
              switch (pattern389 (x14))
                {
                case 0:
                  switch (pattern398 (x9, 
E_HImode))
                    {
                    case 0:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_152 (insn, operands);

                    case 1:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_153 (insn, operands);

                    case 2:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_154 (insn, operands);

                    case 3:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_155 (insn, operands);

                    case 4:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_156 (insn, operands);

                    case 5:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_157 (insn, operands);

                    default:
                      return NULL;
                    }

                case 1:
                  switch (pattern398 (x9, 
E_PSImode))
                    {
                    case 0:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_158 (insn, operands);

                    case 1:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_159 (insn, operands);

                    case 2:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_160 (insn, operands);

                    case 3:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_161 (insn, operands);

                    case 4:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_162 (insn, operands);

                    case 5:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_163 (insn, operands);

                    default:
                      return NULL;
                    }

                case 2:
                  switch (pattern398 (x9, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_164 (insn, operands);

                    case 1:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_165 (insn, operands);

                    case 2:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_166 (insn, operands);

                    case 3:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_167 (insn, operands);

                    case 4:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_168 (insn, operands);

                    case 5:
                      if (!
#line 7313 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_169 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case MINUS:
              if (peep2_current_count < 3)
                return NULL;
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != SCRATCH
                  || GET_MODE (x10) != E_QImode)
                return NULL;
              x16 = XEXP (x9, 1);
              operands[1] = x16;
              x17 = XEXP (x9, 0);
              if (pattern378 (x17) != 0
                  || pattern388 (x6) != 0)
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  switch (pattern399 (x9, 
E_HImode))
                    {
                    case 0:
                      if (!
#line 7418 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_188 (insn, operands);

                    case 1:
                      if (!
#line 7418 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_189 (insn, operands);

                    case 2:
                      if (!
#line 7418 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_190 (insn, operands);

                    case 3:
                      if (!
#line 7418 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_191 (insn, operands);

                    case 4:
                      if (!
#line 7418 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_192 (insn, operands);

                    case 5:
                      if (!
#line 7418 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_193 (insn, operands);

                    default:
                      return NULL;
                    }

                case E_SImode:
                  switch (pattern399 (x9, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 7418 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_194 (insn, operands);

                    case 1:
                      if (!
#line 7418 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_195 (insn, operands);

                    case 2:
                      if (!
#line 7418 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_196 (insn, operands);

                    case 3:
                      if (!
#line 7418 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_197 (insn, operands);

                    case 4:
                      if (!
#line 7418 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_198 (insn, operands);

                    case 5:
                      if (!
#line 7418 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_199 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case ASHIFT:
              if (peep2_current_count < 3)
                return NULL;
              x16 = XEXP (x9, 1);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x10 = XEXP (x3, 0);
              operands[3] = x10;
              if (!scratch_operand (operands[3], E_QImode))
                return NULL;
              x17 = XEXP (x9, 0);
              if (!rtx_equal_p (x17, operands[0]))
                return NULL;
              x11 = XEXP (x7, 1);
              if (GET_CODE (x11) != COMPARE
                  || GET_MODE (x11) != E_CCmode)
                return NULL;
              x15 = XEXP (x11, 1);
              if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x13 = XEXP (x7, 0);
              if (GET_CODE (x13) != REG
                  || REGNO (x13) != 36
                  || GET_MODE (x13) != E_CCmode)
                return NULL;
              switch (pattern390 (x6))
                {
                case 0:
                  switch (pattern400 (x9, 
E_HImode))
                    {
                    case 0:
                      if (!
#line 7552 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_278 (insn, operands);

                    case 1:
                      if (!
#line 7552 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_279 (insn, operands);

                    default:
                      return NULL;
                    }

                case 1:
                  switch (pattern400 (x9, 
E_PSImode))
                    {
                    case 0:
                      if (!
#line 7552 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_280 (insn, operands);

                    case 1:
                      if (!
#line 7552 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_281 (insn, operands);

                    default:
                      return NULL;
                    }

                case 2:
                  switch (pattern400 (x9, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 7552 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_282 (insn, operands);

                    case 1:
                      if (!
#line 7552 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_283 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SET:
      if (peep2_current_count < 2)
        return NULL;
      x18 = XEXP (x1, 1);
      if (GET_CODE (x18) != COMPARE
          || pattern21 (x1) != 0)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern215 (x6) != 0)
        return NULL;
      x19 = XEXP (x18, 0);
      switch (GET_MODE (x19))
        {
        case E_QImode:
          if (!register_operand (x19, E_QImode))
            return NULL;
          operands[0] = x19;
          x20 = XEXP (x18, 1);
          switch (pattern355 (x20, 
E_QImode))
            {
            case 0:
              if (
#line 7769 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_290 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7769 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_291 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x19;
          if (pattern357 (x20, 
E_QImode) != 0
              || !
#line 10383 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_316 (insn, operands);

        case E_QQmode:
          if (!register_operand (x19, E_QQmode))
            return NULL;
          operands[0] = x19;
          x20 = XEXP (x18, 1);
          switch (pattern355 (x20, 
E_QQmode))
            {
            case 0:
              if (
#line 7769 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_292 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7769 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_293 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x19;
          if (pattern357 (x20, 
E_QQmode) != 0
              || !
#line 10383 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_317 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
